#ifndef ___BLE_H_
#define ___BLE_H_

#define DEV_STATUS_ALL_GET			0x60
#define DEV_VENTILATE_SET			0x01
#define DEV_CONTROL					0x05
#define DEV_ID_SET					0x66

#define RESEND_DEV_STS_CNT			1
#define RESEND_AT_ADVDAT_CNT		2

#define UART_WRITE_SN				1
#define APP_WRITE_SN				2


typedef struct BleProtocol
{
    uint8_t header;
    uint8_t cmd;
    uint8_t end;
    uint8_t length;
    uint8_t checksum;

    uint8_t data[255];
} s_BleProtocolData;

typedef struct
{
	struct
	{
		uint8_t SeatedState:1;
		uint8_t IsoFixSwitch:1;
		uint8_t LegLockedSwitch:1;
		uint8_t BuckleSwitch:1;
		uint8_t V5SupplySts:1;
		uint8_t IsAirbagFired:1;
		uint8_t AirbagFireState:1;
		uint8_t PillowSwitch:1;
	}Data0;

	struct
	{
		uint8_t Undefined:2;
		uint8_t FanLevel:2;
		uint8_t TempSensorSts:4;
	}Data1;

	uint8_t FrontBackSwitch; // 30-Front pressed, 90-Back pressed, 255-All not pressed
	uint8_t BatteryLevel;  //0~100%
	uint8_t TempVal;	//-10~50 degree ??? Offset:+10
	uint8_t MajorVersionNum;
	uint8_t MinorVersionNum;
	uint8_t SubdivisionVersionNum;
	uint8_t Resvd2;
}s_DeviceSts_Type;

typedef struct
{
    uint8_t enable;
    uint8_t retryCnt;
    uint8_t waitRespTimeCnt;
    uint8_t recvRespFlag;
} s_UartTxCntl_Type;


extern uint8_t BleConnSts;
extern uint8_t deviceID[4];
extern uint8_t BtWakeTimeCnt;
extern s_UartTxCntl_Type txAtAdvdat;


void BleInit(void);
void BleRxDataProcess(uint8_t rxd);
void BleModuleConnStsRx(uint8_t rxd);
void BleCmdProcess(void);
void BleReportDeviceSts(void);
uint8_t GetBleConnSts(void);
void ProcessBleConnDisconn(void);

#endif
