/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    adc.h
  * @brief   This file contains all the function prototypes for
  *          the adc.c file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __ADC_H__
#define __ADC_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* USER CODE BEGIN Private defines */

#define ADC_REG_REF   						(0xFFFL)
#define VOLE_REF   							(1200)

#define GET_CH_VOLT(chadc,refadc,vlot)	 	(vlot = (chadc*VOLE_REF/refadc))
#define GET_REF_VOLT(refadc,vlot) 			(vlot = ((float)ADC_REG_REF/(float)refadc*(float)VOLE_REF))


typedef enum {
	ADC_BUF_CH_1 = 0,/*0*/
	ADC_BUF_CH_2,	/*0*/
	ADC_BUF_CH_3,	/*0*/
	ADC_BUF_CH_4,	/*0*/
	ADC_BUF_CH_5,	/*0*/
	ADC_BUF_CH_6,	/*0*/
	ADC_BUF_CH_7,	/*0*/
	ADC_BUF_CH_8,	/*0*/
	ADC_BUF_CH_9,	/*0*/
	ADC_BUF_CH_11,	/*0*/
	ADC_BUF_CH_16,	/*0*/
	ADC_BUF_CH_17,	/*0*/
	ADC_BUF_CH_INT,/*0*/
	ADC_BUF_CH_VREF,/*0*/
	ADC_BUF_CH_MAX,
} ADC_BUF_CHANNEL_E;



#define ADC_BUF_BAT_E 		ADC_BUF_CH_1/*adc0*/
#define ADC_BUF_ISOFIXR		ADC_BUF_CH_2/*adc1*/
#define ADC_BUF_ISOFIXL		ADC_BUF_CH_3/*adc2*/
#define ADC_BUF_DIRF		ADC_BUF_CH_4/*adc3*/
#define ADC_BUF_DIRB		ADC_BUF_CH_5/*adc4*/
#define ADC_BUF_LEG			ADC_BUF_CH_6/*adc5*/
#define ADC_BUF_PILLOW		ADC_BUF_CH_7/*adc6*/
#define ADC_BUF_SOS			ADC_BUF_CH_8/*adc7*/
#define ADC_BUF_NTC			ADC_BUF_CH_9/*adc8*/
#define ADC_BUF_VER			ADC_BUF_CH_11/*adc9*/
#define ADC_BUF_RES			ADC_BUF_CH_16/*adc9*/
#define ADC_BUF_5V			ADC_BUF_CH_17/*adc11*/
#define ADC_BUF_BAT		 	ADC_BUF_CH_INT/**/
#define ADC_BUF_MCUVREF		ADC_BUF_CH_VREF/**/
#define ADC_BUF_MAX			ADC_BUF_CH_MAX

void ADC_Test(void);
void ADC_Start(void);
UNS16 ADC_GetChannelValue(ADC_BUF_CHANNEL_E ch);

/* USER CODE END Private defines */

void MX_ADC1_Init(void);

/* USER CODE BEGIN Prototypes */

/* USER CODE END Prototypes */

#ifdef __cplusplus
}
#endif

#endif /* __ADC_H__ */

