#ifndef __DTYPE_H
#define __DTYPE_H
/*****************************************************************************/
 /********************code here*******************/

 /*****************************************************************************/
/** MARCOS AND TYPEDEFs **/
#define _far
typedef unsigned char BOOLEAN;
typedef unsigned char BOOL;
typedef unsigned char UNS8;
typedef UNS8 * UNS8_PTR;
#define MAX_UNS8 (255)
#define MIN_UNS8 (0)
typedef UNS8 _far * FAR_UNS8_PTR;
typedef signed char S8;
#define MAX_S8 (127)
#define MIN_S8 (-128)
typedef S8 * S8_PTR;
typedef S8 _far * FAR_S8_PTR;
typedef unsigned short UNS16;
#define MAX_UNS16 (65535)
#define MIN_UNS16 (0)
typedef UNS16 * UNS16_PTR;
typedef UNS16 _far * FAR_UNS16_PTR;
typedef signed short S16;
#define MAX_S16 (32767)
#define MIN_S16 (-32768)
typedef S16 * S16_PTR;
typedef S16 _far * FAR_S16_PTR;
typedef unsigned long UNS32;
#define MAX_UNS32 (4294967295)
#define MIN_UNS32 (0)
typedef UNS32 * UNS32_PTR;
typedef UNS32 _far * FAR_UNS32_PTR;
typedef signed long S32;
#define MAX_S32 (2147483647)
#define MIN_S32 (-2147483648)
typedef S32 * S32_PTR;
typedef S32 _far * FAR_S32_PTR;
typedef unsigned long long UNS64;
typedef signed long long S64;
/* define bit types */
typedef unsigned char BIT_FIELD;


typedef void (*VOID_FUNCTION_PTR)(void);
typedef UNS8 (*UNS8_RETURN_FUNCTION_PTR)(void);

/* type address bus to allow for easy change */
typedef UNS32 address_bus;

typedef union BIT_BYTE_T
{
	struct
	{									/*  Bit  Access */
	    BIT_FIELD B7:1;					/*    Bit 7     */
	    BIT_FIELD B6:1;					/*    Bit 6     */
	    BIT_FIELD B5:1;					/*    Bit 5     */
	    BIT_FIELD B4:1;					/*    Bit 4     */
	    BIT_FIELD B3:1;					/*    Bit 3     */
	    BIT_FIELD B2:1;					/*    Bit 2     */
	    BIT_FIELD B1:1;					/*    Bit 1     */
	    BIT_FIELD B0:1;					/*    Bit 0     */
	} bit;
	unsigned char byte;					/*  Byte Access */
} BIT_BYTE_T;

/*word data union in byte*/
typedef union
{
	UNS32	Word[1];
	UNS16	Int[2];
	UNS8	Byte[4];
}WORD_INT_BYTE_U;

typedef struct STR_MISC_PARA_T
{
	UNS8                      Unused57:3;
	UNS8                      WIR:1;
	UNS8                      Unused3:1;
	UNS8                      Type:2;
	UNS8                      IsEnabled:1;
} STR_MISC_PARA_T;


typedef struct STR_DTC_ID_T
{
	UNS8                      RootCode;
	UNS8                      HighByte;
	UNS8                      MiddleByte;
	UNS8                      FailureType;
} STR_DTC_ID_T;

typedef struct STR_PID_PARA_T
{
	UNS8 RdEnable : 1;//Rd ��read
	UNS8 WrEnable : 1;//Wr ��write
	UNS8 RdSecurityLevel : 3;
	UNS8 WrSecurityLevel : 3;
}STR_PID_PARA_T;

typedef UNS8 _far * FAR_BYTE_PTR;

#define NOTHING

#define NUM0						(0)
#define NUM1						(1)
#define NUM2						(2)
#define NUM3						(3)
#define NUM4						(4)
#define NUM5						(5)
#define NUM6						(6)
#define NUM7						(7)
#define NUM8						(8)
#define NUM9						(9)
#define NUM10						(10)
#define NUM11						(11)
#define NUM12						(12)
#define NUM13						(13)
#define NUM14						(14)
#define NUM15						(15)
#define NUM16						(16)
#define NUM17						(17)
#define NUM18						(18)
#define NUM19						(19)
#define NUM20						(20)

#define NUM21						(21)
#define NUM22						(22)
#define NUM23						(23)
#define NUM24						(24)
#define NUM25						(25)
#define NUM26						(26)
#define NUM27						(27)
#define NUM28						(28)
#define NUM29						(29)
#define NUM30						(30)
#define NUM31						(31)

#define IS_IN_RANGE(data, min, max) 	(((data) >= (min)) && ((data) <= (max)))
#define IS_OUT_RANGE(data, min, max) 	(((data) < (min)) || ((data) > (max)))

#define IS_OUT_RANGE_BOUNDARY(data, min, max) 	(((data) <= (min)) || ((data) >= (max)))
#define IS_IN_RANGE_NOBOUNDARY(data, min, max) 	(((data) > (min)) && ((data) < (max)))


typedef enum {
	FALSE = 0,
	TRUE =!FALSE,
} BOOL_E;


#define ZERO 0

#endif /* __DTYPE_H */

