/*
 * flash_user.h
 *
 *  Created on: Mar 7, 2024
 *      Author: user
 */

#ifndef INC_FLASH_USER_H_
#define INC_FLASH_USER_H_


void MX_FLASH_Init(void);
void MX_FLASH_UnInit(void);

uint32_t MX_Flash_RD_DevID(void);
uint32_t MX_Flash_RD_DevSN(void);
uint32_t MX_Flash_RD_DevSN2(void);
uint32_t MX_Flash_RD_UpdateFlag(void);
uint32_t MX_Flash_RD_PowerOnRecordFlag(void);


UNS8  MX_Flash_WR_PowerOnRecordFlag(uint32_t flag);
void MX_Flash_WR_DevID(uint32_t id);
void MX_Flash_WR_UpdateFlag(uint32_t flag);
void MX_Flash_WR_DevSN2(uint32_t flag);
void MX_Flash_WR_DevSN(uint32_t flag);


int MX_FlashErasePage(uint32_t addr);
int MX_FlashProgram(uint32_t Address,uint32_t *DataAddress,uint32_t len);


uint32_t MX_Flash_RD_AccOffset(uint32_t *offset);
void MX_Flash_WR_AccOffset(uint32_t *offset);

UNS8 MX_Flash_RD_SN_CharBuffer(uint8_t *buffer);
UNS8 MX_Flash_WR_SN_CharBuffer(uint8_t *buffer);


#endif /* INC_FLASH_USER_H_ */
