/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    gpio.h
  * @brief   This file contains all the function prototypes for
  *          the gpio.c file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __GPIO_H__
#define __GPIO_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* USER CODE BEGIN Private defines */

typedef enum
{
    Bit_RESET = 0,
    Bit_SET = !Bit_RESET
}BitAction;


typedef enum
{
   GPIO_OUT_ADC_POWER = 0,
   GPIO_OUT_CHANGE_OFF,
   GPIO_OUT_MCU_CT1,
   GPIO_OUT_MCU_CT3,
   GPIO_OUT_BST_CTL1,
   GPIO_OUT_BST_CTL2,
   GPIO_OUT_BST_CTL3,
   GPIO_OUT_BST_CTL4,
   GPIO_OUT_BT_RESET,
   GPIO_OUT_FRIE_SAFETY,
   GPIO_OUT_AIR_EN1,
   GPIO_OUT_AIR_EN2,
   GPIO_OUT_AIR_EN3,
   GPIO_OUT_AIRBAG_LED,
   GPIO_OUT_TOUCH_LED,
   GPIO_OUT_TEST,
   GPIO_OUT_LED_POWER,
   GPIO_OUT_LED_BUZZ,
   GPIO_OUT_RES_POWOR,
   GPIO_IN_TOUCH,
   GPIO_IN_SW,
   GPIO_IN_BUCKLE,
} GPIO_CHANNEL_E;


void BSP_SetPC14ToOutput(void);
void BSP_GpioOutBit(GPIO_TypeDef *GPIOx, uint32_t PortValue,uint8_t level);
extern uint8_t BSP_GPIO_Read(uint8_t Channel_ID);
extern void BSP_GPIO_Write(GPIO_CHANNEL_E Channel_ID, uint8_t level);
extern void BSP_GPIOTEST(void);
extern void BSP_ProgramEnableCall(void);
/* USER CODE END Private defines */

void MX_GPIO_Init(void);

/* USER CODE BEGIN Prototypes */

/* USER CODE END Prototypes */

#ifdef __cplusplus
}
#endif
#endif /*__ GPIO_H__ */

