/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "stm32u5xx_ll_adc.h"
#include "stm32u5xx_ll_dma.h"
#include "stm32u5xx_ll_lptim.h"
#include "stm32u5xx_ll_pwr.h"
#include "stm32u5xx_ll_crs.h"
#include "stm32u5xx_ll_rcc.h"
#include "stm32u5xx_ll_bus.h"
#include "stm32u5xx_ll_system.h"
#include "stm32u5xx_ll_exti.h"
#include "stm32u5xx_ll_cortex.h"
#include "stm32u5xx_ll_utils.h"
#include "stm32u5xx_ll_rtc.h"
#include "stm32u5xx_ll_spi.h"
#include "stm32u5xx_ll_tim.h"
#include "stm32u5xx_ll_usart.h"
#include "stm32u5xx_ll_wwdg.h"
#include "stm32u5xx_ll_gpio.h"
#include "stm32u5xx_ll_lpgpio.h"

#if defined(USE_FULL_ASSERT)
#include "stm32_assert.h"
#endif /* USE_FULL_ASSERT */

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "ver.h"
#include "string.h"
#include "dtype.h"
#include "cTask.h"
#include "cTask_cfg.h"
#include "cTaskApp.h"
#include <pwr.h>
#include <iokey.h>
#include <74lv595.h>
#include "wwdg.h"
#include "spi.h"
#include "rtc.h"
#include "lptim.h"
#include "gpio.h"
#include "adc.h"
#include "adckey.h"
#include "iokey.h"
#include "disp.h"
#include "fan.h"
#include "tim.h"
#include "usart.h"
#include "alarm.h"
#include "../acc/accel.h"


#include "../dpl/ercap.h"
#include "../dpl/dpl.h"
#include "../dpl/fltc.h"
#include "../dpl/diag.h"

#include "../algo/caw_config.h"
#include "../algo/caw.h"
#include "../algo/front.h"
#include "flash_user.h"

#include "../BLE/EDR.h"
#include "../BLE/BLE.h"
#include "../BLE/flash_hal.h"
#include "../BLE/flash.h"
#include "../BLE/flash_ex.h"

#include "temp.h"
#include "debug.h"
#include "test.h"

#include "rec.h"
#include "../acc/ABA2000.h"
/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/*Enable uart print*/
#define URAT_DEBUG_ENABLE

#define LOG 	printf

#ifdef URAT_DEBUG_ENABLE
#define debug 	printf
#else
#define debug(str)
#endif /* USER_URAT_DEBUG */

#define WAKEUP_TEST  1
#define AUTO_WAKEUP_ENABLE

//#define IO_LOW_POWER_ENABLE

/******Download Selection options******/
//#define DOWNLOAD_SELECTION_ENABLE						/////////////

//#define PROGRAMMING_PORT_DISABLED    /*Official release requires opening*/

/******disp  options******/


#define DISP_DIODE_REVERSAL_ENABLE    /**/


/******Ignition debug  options******/


//#define ACC_DATA_INPUT_TEST_ENABLE
//#define ACC_SLEEP_TEST_ENABLE 		/*acc sleep*/


//#define ALGO_LOW_TEST_ENABLE
//#define ACC_TO_FIRE_TEST_ENABLE							/*Skip algorithm*/

//#define LOOP_HIGH_MODE_TEST_ENABLE  					/*high power run*/
//#define NO_SWITCH_CHECK_FIRE_TEST_ENABLE    			/*Skip switch detection*/
//#define NO_RES_CHECK_TEST_ENABLE


//#define REC_TO_FLASH_TEST_ENABLE

//#define REC_ON_FLASH_SAVE_TEST_ENABLE

//#define REC_UNLOCK_RAM_TEST_ENABLE

#define     	REC_UNLOCK_CONTINUOUS_SAVE_TEST_ENABLE


//#define SLEEP_JMP_HIGH_TEST_MODE  	/*loop high*/
//#define SLEEP_TEST_MODE   			/*3S off*/
//#define DEBUG_PA13_14_AALTER_TEST_MODE   	/*Debugging pin settings*/



/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define ADC_POWER_EN_PC13_Pin LL_GPIO_PIN_13
#define ADC_POWER_EN_PC13_GPIO_Port GPIOC
#define SPI2_CS1_PB12_Pin LL_GPIO_PIN_12
#define SPI2_CS1_PB12_GPIO_Port GPIOB
#define SPI2_CS2_PC6_Pin LL_GPIO_PIN_6
#define SPI2_CS2_PC6_GPIO_Port GPIOC
#define RES_DEC_Pin LL_GPIO_PIN_8
#define RES_DEC_GPIO_Port GPIOC
#define BUCKLE_IN_PC9_Pin LL_GPIO_PIN_9
#define BUCKLE_IN_PC9_GPIO_Port GPIOC
#define BST_CTL4_PA8_Pin LL_GPIO_PIN_8
#define BST_CTL4_PA8_GPIO_Port GPIOA
#define MCU_CT1_OUT_PA9_Pin LL_GPIO_PIN_9
#define MCU_CT1_OUT_PA9_GPIO_Port GPIOA
#define BST_CTL2_PA10_Pin LL_GPIO_PIN_10
#define BST_CTL2_PA10_GPIO_Port GPIOA
#define BST_CTL1_PA11_Pin LL_GPIO_PIN_11
#define BST_CTL1_PA11_GPIO_Port GPIOA
#define Touch_IN_PA12_Pin LL_GPIO_PIN_12
#define Touch_IN_PA12_GPIO_Port GPIOA
#define BT_Reset_PC12_Pin LL_GPIO_PIN_12
#define BT_Reset_PC12_GPIO_Port GPIOC
#define LED_POWER_EN_PD2_Pin LL_GPIO_PIN_2
#define LED_POWER_EN_PD2_GPIO_Port GPIOD
#define SW_IN_PB5_Pin LL_GPIO_PIN_5
#define SW_IN_PB5_GPIO_Port GPIOB
#define BT_WAKE_PB6_Pin LL_GPIO_PIN_6
#define BT_WAKE_PB6_GPIO_Port GPIOB
#define BT_CONN_PB7_Pin LL_GPIO_PIN_7
#define BT_CONN_PB7_GPIO_Port GPIOB
#define IMU_INT2_Pin LL_GPIO_PIN_8
#define IMU_INT2_GPIO_Port GPIOB
#define IMU_INT1_Pin LL_GPIO_PIN_9
#define IMU_INT1_GPIO_Port GPIOB
#define IMU_INT1_EXTI_IRQn EXTI9_IRQn
#ifndef NVIC_PRIORITYGROUP_0
#define NVIC_PRIORITYGROUP_0         ((uint32_t)0x00000007) /*!< 0 bit  for pre-emption priority,
                                                                 4 bits for subpriority */
#define NVIC_PRIORITYGROUP_1         ((uint32_t)0x00000006) /*!< 1 bit  for pre-emption priority,
                                                                 3 bits for subpriority */
#define NVIC_PRIORITYGROUP_2         ((uint32_t)0x00000005) /*!< 2 bits for pre-emption priority,
                                                                 2 bits for subpriority */
#define NVIC_PRIORITYGROUP_3         ((uint32_t)0x00000004) /*!< 3 bits for pre-emption priority,
                                                                 1 bit  for subpriority */
#define NVIC_PRIORITYGROUP_4         ((uint32_t)0x00000003) /*!< 4 bits for pre-emption priority,
                                                                 0 bit  for subpriority */
#endif

/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
