/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    spi.h
  * @brief   This file contains all the function prototypes for
  *          the spi.c file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __SPI_H__
#define __SPI_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* USER CODE BEGIN Private defines */

//typedef enum
//{
//   SPI2_CS1 = 0,
//   SPI2_CS2,
//} SPI2_CS_SELECTOR_E;





typedef enum
{
   SPI_NO_ERROR = 0,
   SPI_ERROR_WAIT_TXP,
   SPI_ERROR_WAIT_EOT,
   SPI_ERROR_WAIT_RXP,
} SPI_ERROR_E;

typedef enum
{
	SPI2_CS_1 = 0,
	SPI2_CS_2,
	SPI2_CS_3,
	SPI1_CS,
	SPI_CS_MAX,
} CS_SELECT_E;


uint8_t SPI2_Write8Bit(uint8_t  cs,uint8_t addr, uint8_t* data_buffer);
uint8_t SPI2_Write16Bit(uint8_t  cs,uint16_t* data_buffer);

extern void SPI_test(void);
extern uint8_t SPI1_TransmitBuffer(uint32_t data);
extern uint8_t SPI1_Write32Bit(uint32_t  data_buffer);
/* USER CODE END Private defines */

void MX_SPI1_Init(void);
void MX_SPI2_Init(void);
uint8_t SPI2_WriteFixedMultipleBit(uint8_t  cs,uint8_t addr,uint32_t *data_buffer);

UNS8 SPI2_Write32Bit(UNS8 cs,UNS32 cmd,UNS32 *data);
/* USER CODE BEGIN Prototypes */

/* USER CODE END Prototypes */

#ifdef __cplusplus
}
#endif

#endif /* __SPI_H__ */

