/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    tim.h
  * @brief   This file contains all the function prototypes for
  *          the tim.c file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __TIM_H__
#define __TIM_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* USER CODE BEGIN Private defines */

typedef enum {
	SYS_RATE_80M= 0,
	SYS_RATE_4M,
	SYS_RATE_MAX,
} SYS_RATE_E;

extern void BSP_StartPwm(void);
extern void BSP_SetPwm3Compare(uint32_t CompareValue);
extern void BSP_SetPwm2Compare(uint32_t CompareValue);
extern void BSP_Pwm2Enable(void);
extern void BSP_Pwm3Enable(void);
extern void MX_TIM1_80M_Init(void);
extern void MX_TIM1_4M_Init(void);
extern void MX_TIM1_InitPeriod(SYS_RATE_E Pcr);
extern void MX_TIM2_InitPeriod(SYS_RATE_E Pcr);
/* USER CODE END Private defines */

void MX_TIM1_Init(void);
void MX_TIM2_Init(void);
void MX_TIM3_Init(void);

/* USER CODE BEGIN Prototypes */

/* USER CODE END Prototypes */

#ifdef __cplusplus
}
#endif

#endif /* __TIM_H__ */

