/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    gpio.c
  * @brief   This file provides code for the configuration
  *          of all used GPIO pins.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "gpio.h"

/* USER CODE BEGIN 0 */
/*POWER_EN 		- PC13 Output*/
/*MCU_CT2 		- PC14 Output*/
/*MCU_CT3 		- PC15 Output*/
/*SPI1_CS0		- PB0  Output*/
/*SPI2_CS1		- PB12 Output*/
/*SPI2_CS2		- PC6  Output*/
/*MCU_INT1		- PC7  Input + pull up*/
/*MCU_INT2		- PC8  Input + pull up*/
/*GPIO			- PC9  Input*/
/*BST_CTL4		- PA8  Output*/
/*BST_CTL3		- PA9  Output*/
/*BST_CTL2		- PA10 Output*/
/*BST_CTL1		- PA11 Output*/
/*Touch			- PA12 Input*/
/*BT_Reset		- PC12 Output*/
/*SW			- PB5  Input Low valid*/
/*AIR_EN1		- PB6 Output*/
/*AIR_EN2		- PB7 Output*/
/*AIR_EN3		- PB8 Output*/
/*Touch_led		- PB9 Output*/

/* USER CODE END 0 */

/*----------------------------------------------------------------------------*/
/* Configure GPIO                                                             */
/*----------------------------------------------------------------------------*/
/* USER CODE BEGIN 1 */
void BSP_ProgramDisabledCall(void);
void BSP_ProgramEnableCall(void);
/* USER CODE END 1 */

/** Configure pins as
        * Analog
        * Input
        * Output
        * EVENT_OUT
        * EXTI
*/
static g_gpioInitFlg = 0;

void MX_GPIO_Init(void)
{

  LL_EXTI_InitTypeDef EXTI_InitStruct = {0};
  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  LL_AHB2_GRP1_EnableClock(LL_AHB2_GRP1_PERIPH_GPIOC);
  LL_AHB2_GRP1_EnableClock(LL_AHB2_GRP1_PERIPH_GPIOH);
  LL_AHB2_GRP1_EnableClock(LL_AHB2_GRP1_PERIPH_GPIOA);
  LL_AHB2_GRP1_EnableClock(LL_AHB2_GRP1_PERIPH_GPIOB);
  LL_AHB2_GRP1_EnableClock(LL_AHB2_GRP1_PERIPH_GPIOD);

  /**/
  LL_GPIO_ResetOutputPin(GPIOC, ADC_POWER_EN_PC13_Pin|LL_GPIO_PIN_15);

  /**/
  LL_GPIO_ResetOutputPin(GPIOA, LL_GPIO_PIN_15);

  /**/
  LL_GPIO_ResetOutputPin(LED_POWER_EN_PD2_GPIO_Port, LED_POWER_EN_PD2_Pin);

  /**/
  LL_GPIO_SetOutputPin(GPIOB, SPI2_CS1_PB12_Pin|BT_WAKE_PB6_Pin | LL_GPIO_PIN_3 );

  if(g_gpioInitFlg == 0){
	  g_gpioInitFlg = 1;
	  LL_GPIO_ResetOutputPin(GPIOB, LL_GPIO_PIN_4 );
  }else{
	  if(AdKey_GetAccIntStatus()){
		  LL_GPIO_ResetOutputPin(GPIOB, LL_GPIO_PIN_4 );
	  }else{
		  LL_GPIO_SetOutputPin(GPIOB, LL_GPIO_PIN_4 );
	  }


  }


  /**/
  LL_GPIO_SetOutputPin(GPIOC, SPI2_CS2_PC6_Pin|RES_DEC_Pin|BT_Reset_PC12_Pin);

  /**/
  LL_GPIO_SetOutputPin(GPIOA, BST_CTL4_PA8_Pin|MCU_CT1_OUT_PA9_Pin|BST_CTL2_PA10_Pin|BST_CTL1_PA11_Pin);

  /**/
#ifdef PROGRAMMING_PORT_DISABLED
  BSP_ProgramDisabledCall();
#endif


  /**/  GPIO_InitStruct.Pin = ADC_POWER_EN_PC13_Pin|LL_GPIO_PIN_15|RES_DEC_Pin|BT_Reset_PC12_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = LL_GPIO_PIN_14;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = SPI2_CS1_PB12_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_VERY_HIGH;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(SPI2_CS1_PB12_GPIO_Port, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = SPI2_CS2_PC6_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_VERY_HIGH;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(SPI2_CS2_PC6_GPIO_Port, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = BUCKLE_IN_PC9_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(BUCKLE_IN_PC9_GPIO_Port, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = BST_CTL4_PA8_Pin|MCU_CT1_OUT_PA9_Pin|BST_CTL2_PA10_Pin|BST_CTL1_PA11_Pin
                          |LL_GPIO_PIN_15;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = Touch_IN_PA12_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_DOWN;
  LL_GPIO_Init(Touch_IN_PA12_GPIO_Port, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = LED_POWER_EN_PD2_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(LED_POWER_EN_PD2_GPIO_Port, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = SW_IN_PB5_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_UP;
  LL_GPIO_Init(SW_IN_PB5_GPIO_Port, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = BT_WAKE_PB6_Pin |LL_GPIO_PIN_3|LL_GPIO_PIN_4;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(BT_WAKE_PB6_GPIO_Port, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = BT_CONN_PB7_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(BT_CONN_PB7_GPIO_Port, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = IMU_INT2_Pin;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_DOWN;
  LL_GPIO_Init(IMU_INT2_GPIO_Port, &GPIO_InitStruct);

  /**/
  LL_EXTI_SetEXTISource(LL_EXTI_EXTI_PORTB, LL_EXTI_EXTI_LINE9);

  /**/
  EXTI_InitStruct.Line_0_31 = LL_EXTI_LINE_9;
  EXTI_InitStruct.LineCommand = ENABLE;
  EXTI_InitStruct.Mode = LL_EXTI_MODE_IT;
  EXTI_InitStruct.Trigger = LL_EXTI_TRIGGER_RISING;
  LL_EXTI_Init(&EXTI_InitStruct);

  /**/
  LL_GPIO_SetPinPull(IMU_INT1_GPIO_Port, IMU_INT1_Pin, LL_GPIO_PULL_DOWN);

  /**/
  LL_GPIO_SetPinMode(IMU_INT1_GPIO_Port, IMU_INT1_Pin, LL_GPIO_MODE_INPUT);

  /* EXTI interrupt init*/
  NVIC_SetPriority(EXTI9_IRQn, NVIC_EncodePriority(NVIC_GetPriorityGrouping(),0, 0));
  NVIC_EnableIRQ(EXTI9_IRQn);

}

/* USER CODE BEGIN 2 */

void BSP_GpioOutBit(GPIO_TypeDef *GPIOx, uint32_t PortValue,uint8_t level)
{
	if(level == Bit_SET){
		LL_GPIO_SetOutputPin(GPIOx,PortValue);
	}else{
		LL_GPIO_ResetOutputPin(GPIOx,PortValue);
	}
}



void BSP_GPIO_Write(GPIO_CHANNEL_E Channel_ID, uint8_t level)
{
	uint8_t gpioLevel = Bit_SET;

	if(level == Bit_RESET)
	{gpioLevel = Bit_RESET;}

	switch (Channel_ID)
	{
		case GPIO_OUT_ADC_POWER :
				BSP_GpioOutBit(GPIOC, LL_GPIO_PIN_13, gpioLevel);
			break;
		case GPIO_OUT_CHANGE_OFF :
				BSP_GpioOutBit(GPIOC, LL_GPIO_PIN_14, gpioLevel);
			break;
		case GPIO_OUT_MCU_CT1:
			  // BSP_GpioOutBit(GPIOA, LL_GPIO_PIN_9, gpioLevel);
//			break;
//		case GPIO_OUT_MCU_CT2 :
//				BSP_GpioOutBit(GPIOC, LL_GPIO_PIN_15, gpioLevel);
			break;
		case GPIO_OUT_MCU_CT3 :
//				BSP_GpioOutBit(GPIOC, LL_GPIO_PIN_15, gpioLevel);
			break;
		case GPIO_OUT_BST_CTL4 :
//				BSP_GpioOutBit(GPIOA, LL_GPIO_PIN_8, gpioLevel);
			break;
		case GPIO_OUT_BST_CTL3 :
//				BSP_GpioOutBit(GPIOA, LL_GPIO_PIN_9, gpioLevel);
			break;
		case GPIO_OUT_BST_CTL2 :
//				BSP_GpioOutBit(GPIOA, LL_GPIO_PIN_10, gpioLevel);
			break;
		case GPIO_OUT_BST_CTL1 :
//				BSP_GpioOutBit(GPIOA, LL_GPIO_PIN_11, gpioLevel);
			break;
		case GPIO_OUT_BT_RESET :
				BSP_GpioOutBit(GPIOC, LL_GPIO_PIN_12, gpioLevel);
			break;
		case GPIO_OUT_FRIE_SAFETY:
			BSP_GpioOutBit(GPIOA, LL_GPIO_PIN_11, gpioLevel);
			break;
//		case GPIO_OUT_AIR_EN1 :
//				BSP_GpioOutBit(GPIOB, LL_GPIO_PIN_6, gpioLevel);
//			break;
//		case GPIO_OUT_AIR_EN2 :
//				BSP_GpioOutBit(GPIOB, LL_GPIO_PIN_7, gpioLevel);
//			break;
//		case GPIO_OUT_AIR_EN3 :
//				BSP_GpioOutBit(GPIOB, LL_GPIO_PIN_8, gpioLevel);
//			break;
		case GPIO_OUT_AIRBAG_LED :
				BSP_GpioOutBit(GPIOB, LL_GPIO_PIN_9, gpioLevel);
				break;
//		case GPIO_OUT_TOUCH_LED :
//				BSP_GpioOutBit(GPIOB, LL_GPIO_PIN_9, gpioLevel);
//				break;
//		case GPIO_OUT_LED_BUZZ:
//				BSP_GpioOutBit(GPIOB, LL_GPIO_PIN_10, gpioLevel);
//				break;
		case GPIO_OUT_RES_POWOR:
				BSP_GpioOutBit(GPIOC, LL_GPIO_PIN_8, gpioLevel);
				break;
		case GPIO_OUT_LED_POWER :
				BSP_GpioOutBit(GPIOD, LL_GPIO_PIN_2, gpioLevel);
				break;
		case GPIO_OUT_TEST :
				BSP_GpioOutBit(GPIOA, LL_GPIO_PIN_15, gpioLevel);
			break;
		default:
			break;
	}
}
/*Touch			- PA12 Input*/
/*SW			- PB5  Input Low valid*/
uint8_t BSP_GPIO_Read(uint8_t Channel_ID)
{
	uint8_t gpioLevel = Bit_SET;
	switch (Channel_ID)
	{
	    case GPIO_IN_TOUCH :
	    		gpioLevel = LL_GPIO_IsInputPinSet(GPIOA,LL_GPIO_PIN_12);
	    	break;
		case GPIO_IN_SW :
				gpioLevel = LL_GPIO_IsInputPinSet(GPIOB,LL_GPIO_PIN_5);
			break;
		case GPIO_IN_BUCKLE :
				gpioLevel = LL_GPIO_IsInputPinSet(GPIOC,LL_GPIO_PIN_9);
			break;
		default :
			break;
	}

	if(Bit_SET != gpioLevel)
	{return 0;}

	return 1;
}

void BSP_SetPC14ToOutput(void)
{
	LL_GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin = LL_GPIO_PIN_14;
	GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
	GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
	LL_GPIO_Init(GPIOC, &GPIO_InitStruct);
	LL_GPIO_ResetOutputPin(GPIOC,LL_GPIO_PIN_14);

}




void BSP_GPIOTEST(void)
{
	LL_GPIO_TogglePin(GPIOA,LL_GPIO_PIN_15);
}


void BSP_ProgramDisabledCall(void)
{
  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};
  /**/
  GPIO_InitStruct.Pin = LL_GPIO_PIN_13|LL_GPIO_PIN_14;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_OPENDRAIN;
  LL_GPIO_Init(GPIOA, &GPIO_InitStruct);
  /**/
  GPIO_InitStruct.Pin = LL_GPIO_PIN_3|LL_GPIO_PIN_4;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_OPENDRAIN;
  LL_GPIO_Init(GPIOB, &GPIO_InitStruct);
//  LL_GPIO_PinRemapConfig();
}

void BSP_ProgramEnableCall(void)
{
  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};
  /**/
  GPIO_InitStruct.Pin = LL_GPIO_PIN_13 |LL_GPIO_PIN_14;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_HIGH;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  LL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /**/
  GPIO_InitStruct.Pin = LL_GPIO_PIN_3|LL_GPIO_PIN_4;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_OPENDRAIN;
  LL_GPIO_Init(GPIOB, &GPIO_InitStruct);

}

/* USER CODE END 2 */
