/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    lptim.c
  * @brief   This file provides code for the configuration
  *          of the LPTIM instances.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "lptim.h"

/* USER CODE BEGIN 0 */

const static UNS16 LP_Count = 50;
const static UNS16 LP_Period = 25;

const static UNS16 PWM_Period = 100;
//const static UNS16 PWM_Pulse1 = 0;
const static UNS16 PWM_Pulse2 = 0;

/* USER CODE END 0 */

/* LPTIM1 init function */
void MX_LPTIM1_Init(void)
{

  /* USER CODE BEGIN LPTIM1_Init 0 */

  /* USER CODE END LPTIM1_Init 0 */

  LL_RCC_SetLPTIMClockSource(LL_RCC_LPTIM2_CLKSOURCE_HSI);

  /* Peripheral clock enable */
  LL_APB3_GRP1_EnableClock(LL_APB3_GRP1_PERIPH_LPTIM1);

  /* LPTIM1 interrupt Init */
  NVIC_SetPriority(LPTIM1_IRQn, NVIC_EncodePriority(NVIC_GetPriorityGrouping(),7, 0));
  NVIC_EnableIRQ(LPTIM1_IRQn);

  /* USER CODE BEGIN LPTIM1_Init 1 */

  /* USER CODE END LPTIM1_Init 1 */
  LL_LPTIM_Enable(LPTIM1);
  LL_LPTIM_ClearFlag_REPOK(LPTIM1);
  LL_LPTIM_SetRepetition(LPTIM1, LP_Count);

   /* Wait till REPOK Flag is ready */
  while(!LL_LPTIM_IsActiveFlag_REPOK(LPTIM1))
  {
  }
  LL_LPTIM_ClearFlag_ARROK(LPTIM1);
  LL_LPTIM_SetAutoReload(LPTIM1, LP_Period);

   /* Wait till ARROK Flag is ready */
  while(!LL_LPTIM_IsActiveFlag_ARROK(LPTIM1))
  {
  }
  LL_LPTIM_Disable(LPTIM1);
  LL_LPTIM_SetClockSource(LPTIM1, LL_LPTIM_CLK_SOURCE_INTERNAL);
  LL_LPTIM_SetPrescaler(LPTIM1, LL_LPTIM_PRESCALER_DIV4);
  LL_LPTIM_SetUpdateMode(LPTIM1, LL_LPTIM_UPDATE_MODE_IMMEDIATE);
  LL_LPTIM_SetCounterMode(LPTIM1, LL_LPTIM_COUNTER_MODE_INTERNAL);
  LL_LPTIM_TrigSw(LPTIM1);
  LL_LPTIM_SetInput1Src(LPTIM1, LL_LPTIM_INPUT1_SRC_GPIO);
  LL_LPTIM_SetInput2Src(LPTIM1, LL_LPTIM_INPUT2_SRC_GPIO);
  /* USER CODE BEGIN LPTIM1_Init 2 */

//	LL_LPTIM_CC_SetChannelMode(LPTIM1, LL_LPTIM_CHANNEL_CH1,LL_LPTIM_CCMODE_OUTPUT_PWM);
	LL_LPTIM_Enable(LPTIM1);
	LL_LPTIM_EnableIT_UE(LPTIM1);
	LL_LPTIM_StartCounter(LPTIM1, LL_LPTIM_OPERATING_MODE_CONTINUOUS);

  /* USER CODE END LPTIM1_Init 2 */

}
/* LPTIM3 init function */
void MX_LPTIM3_Init(void)
{

  /* USER CODE BEGIN LPTIM3_Init 0 */

  /* USER CODE END LPTIM3_Init 0 */

  LL_RCC_SetLPTIMClockSource(LL_RCC_LPTIM34_CLKSOURCE_HSI);

  /* Peripheral clock enable */
  LL_APB3_GRP1_EnableClock(LL_APB3_GRP1_PERIPH_LPTIM3);

  /* USER CODE BEGIN LPTIM3_Init 1 */

  /* USER CODE END LPTIM3_Init 1 */
  LL_LPTIM_Enable(LPTIM3);
  LL_LPTIM_ClearFlag_REPOK(LPTIM3);
  LL_LPTIM_SetRepetition(LPTIM3, 0);

   /* Wait till REPOK Flag is ready */
  while(!LL_LPTIM_IsActiveFlag_REPOK(LPTIM3))
  {
  }
  LL_LPTIM_ClearFlag_ARROK(LPTIM3);
  LL_LPTIM_SetAutoReload(LPTIM3, PWM_Period);

   /* Wait till ARROK Flag is ready */
  while(!LL_LPTIM_IsActiveFlag_ARROK(LPTIM3))
  {
  }
  LL_LPTIM_Disable(LPTIM3);
  LL_LPTIM_SetClockSource(LPTIM3, LL_LPTIM_CLK_SOURCE_INTERNAL);
  LL_LPTIM_SetPrescaler(LPTIM3, LL_LPTIM_PRESCALER_DIV4);
  LL_LPTIM_SetUpdateMode(LPTIM3, LL_LPTIM_UPDATE_MODE_IMMEDIATE);
  LL_LPTIM_SetCounterMode(LPTIM3, LL_LPTIM_COUNTER_MODE_INTERNAL);
  LL_LPTIM_TrigSw(LPTIM3);
  LL_LPTIM_SetInput1Src(LPTIM3, LL_LPTIM_INPUT1_SRC_GPIO);
  LL_LPTIM_Enable(LPTIM3);
  LL_LPTIM_ClearFlag_CMP2OK(LPTIM3);
  LL_LPTIM_SetCompareCH2(LPTIM3, PWM_Pulse2);

   /* Wait till CMP2OK Flag is ready */
  while(!LL_LPTIM_IsActiveFlag_CMP2OK(LPTIM3))
  {
  }
  LL_LPTIM_Disable(LPTIM3);
  LL_LPTIM_OC_SetPolarity(LPTIM3, LL_LPTIM_CHANNEL_CH2, LL_LPTIM_OUTPUT_POLARITY_INVERSE);
  /* USER CODE BEGIN LPTIM3_Init 2 */
  BSP_PWMEnable();
  /* USER CODE END LPTIM3_Init 2 */

}

/* USER CODE BEGIN 1 */

/* LPTIM3 init function */
void BSP_PWMEnable(void)
{
	//LL_LPTIM_CC_EnableChannel(LPTIM3,LL_LPTIM_CHANNEL_CH1);
	LL_LPTIM_CC_EnableChannel(LPTIM3,LL_LPTIM_CHANNEL_CH2);
	LL_LPTIM_Enable(LPTIM3);
	LL_LPTIM_StartCounter(LPTIM3,LL_LPTIM_OPERATING_MODE_CONTINUOUS);
}





//
//void BSP_SetPwm2Compare(uint32_t CompareValue)
//{
////	 LL_TIM_OC_SetCompareCH3(TIM2, CompareValue);
//	UNS32 PwmCompa;
//	if(CompareValue <= PWM_Period){
//		PwmCompa = CompareValue;
//	}else{PwmCompa = PWM_Period;}
//
//	LL_LPTIM_SetCompareCH1(LPTIM3, PwmCompa);
//	if(PwmCompa == PWM_Pulse1){
//		LL_LPTIM_CC_DisableChannel(LPTIM3,LL_LPTIM_CHANNEL_CH1);
//	}else{LL_LPTIM_CC_EnableChannel(LPTIM3,LL_LPTIM_CHANNEL_CH1);}
//
//	LL_LPTIM_Enable(LPTIM3);
//	LL_LPTIM_StartCounter(LPTIM3,LL_LPTIM_OPERATING_MODE_CONTINUOUS);
//}
//void BSP_SetPwm3Compare(uint32_t CompareValue)
//{
////	 LL_TIM_OC_SetCompareCH4(TIM3, CompareValue);
//	UNS32 PwmCompa;
//	if(CompareValue <= PWM_Period){
//		PwmCompa = CompareValue;
//	}else{PwmCompa = PWM_Period;}
//
//	LL_LPTIM_SetCompareCH2(LPTIM3, PwmCompa);
//	if(PwmCompa == PWM_Pulse2){
//		LL_LPTIM_CC_DisableChannel(LPTIM3,LL_LPTIM_CHANNEL_CH2);
//	}else{
//	LL_LPTIM_CC_EnableChannel(LPTIM3,LL_LPTIM_CHANNEL_CH2);
//	LL_LPTIM_Enable(LPTIM3);
//	LL_LPTIM_StartCounter(LPTIM3,LL_LPTIM_OPERATING_MODE_CONTINUOUS);}
//
//
//}

/* USER CODE END 1 */
