/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    usart.c
  * @brief   This file provides code for the configuration
  *          of the USART instances.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "usart.h"

/* USER CODE BEGIN 0 */

#ifdef __GNUC__
#define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#define GETCHAR_PROTOTYPE int __io_getchar(FILE *f)
#else
#define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#define GETCHAR_PROTOTYPE int fgetc(FILE *f)
#endif /* __GNUC__ */

PUTCHAR_PROTOTYPE
{
	UNS16 TimeOut = 0xffff;
	while((LL_USART_IsActiveFlag_TC(USART3)!=1) && (TimeOut--)){};/*wiet*/
	LL_USART_TransmitData8(USART3,ch);
	//HAL_UART_Transmit(&huart3, (uint8_t *)&ch, 1, 0xFFFF);
	return ch;
}

uint8_t USART1_RX_BUF[USART1_REC_LEN];

/* USER CODE END 0 */

/* UART4 init function */
void MX_UART4_Init(void)
{

  /* USER CODE BEGIN UART4_Init 0 */

  /* USER CODE END UART4_Init 0 */

  LL_USART_InitTypeDef UART_InitStruct = {0};

  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};

  LL_RCC_SetUARTClockSource(LL_RCC_UART4_CLKSOURCE_HSI);

  /* Peripheral clock enable */
  LL_APB1_GRP1_EnableClock(LL_APB1_GRP1_PERIPH_UART4);

  LL_AHB2_GRP1_EnableClock(LL_AHB2_GRP1_PERIPH_GPIOC);
  /**UART4 GPIO Configuration
  PC10   ------> UART4_TX
  PC11   ------> UART4_RX
  */
  GPIO_InitStruct.Pin = LL_GPIO_PIN_10;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_8;
  LL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  GPIO_InitStruct.Pin = LL_GPIO_PIN_11;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_UP;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_8;
  LL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /* UART4 interrupt Init */
  NVIC_SetPriority(UART4_IRQn, NVIC_EncodePriority(NVIC_GetPriorityGrouping(),1, 0));
  NVIC_EnableIRQ(UART4_IRQn);

  /* USER CODE BEGIN UART4_Init 1 */

  /* USER CODE END UART4_Init 1 */
  UART_InitStruct.BaudRate = 115200;
  UART_InitStruct.DataWidth = LL_USART_DATAWIDTH_8B;
  UART_InitStruct.StopBits = LL_USART_STOPBITS_1;
  UART_InitStruct.Parity = LL_USART_PARITY_NONE;
  UART_InitStruct.TransferDirection = LL_USART_DIRECTION_TX_RX;
  UART_InitStruct.HardwareFlowControl = LL_USART_HWCONTROL_NONE;
  UART_InitStruct.OverSampling = LL_USART_OVERSAMPLING_16;
  LL_USART_Init(UART4, &UART_InitStruct);
  LL_USART_ConfigAsyncMode(UART4);
  LL_USART_Enable(UART4);
  /* USER CODE BEGIN UART4_Init 2 */
  LL_USART_EnableIT_RXNE(UART4);
  /* USER CODE END UART4_Init 2 */

}
/* USART3 init function */

void MX_USART3_UART_Init(void)
{

  /* USER CODE BEGIN USART3_Init 0 */

  /* USER CODE END USART3_Init 0 */

  LL_USART_InitTypeDef USART_InitStruct = {0};

  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};

  LL_RCC_SetUSARTClockSource(LL_RCC_USART3_CLKSOURCE_HSI);

  /* Peripheral clock enable */
  LL_APB1_GRP1_EnableClock(LL_APB1_GRP1_PERIPH_USART3);

  LL_AHB2_GRP1_EnableClock(LL_AHB2_GRP1_PERIPH_GPIOC);
  /**USART3 GPIO Configuration
  PC4   ------> USART3_TX
  PC5   ------> USART3_RX
  */
  GPIO_InitStruct.Pin = LL_GPIO_PIN_4;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_7;
  LL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  GPIO_InitStruct.Pin = LL_GPIO_PIN_5;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_UP;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_7;
  LL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /* USART3 interrupt Init */
  NVIC_SetPriority(USART3_IRQn, NVIC_EncodePriority(NVIC_GetPriorityGrouping(),1, 0));
  NVIC_EnableIRQ(USART3_IRQn);

  /* USER CODE BEGIN USART3_Init 1 */

  /* USER CODE END USART3_Init 1 */
  USART_InitStruct.PrescalerValue = LL_USART_PRESCALER_DIV1;
  USART_InitStruct.BaudRate = 115200;
  USART_InitStruct.DataWidth = LL_USART_DATAWIDTH_8B;
  USART_InitStruct.StopBits = LL_USART_STOPBITS_1;
  USART_InitStruct.Parity = LL_USART_PARITY_NONE;
  USART_InitStruct.TransferDirection = LL_USART_DIRECTION_TX_RX;
  USART_InitStruct.HardwareFlowControl = LL_USART_HWCONTROL_NONE;
  USART_InitStruct.OverSampling = LL_USART_OVERSAMPLING_16;
  LL_USART_Init(USART3, &USART_InitStruct);
  LL_USART_SetTXFIFOThreshold(USART3, LL_USART_FIFOTHRESHOLD_1_8);
  LL_USART_SetRXFIFOThreshold(USART3, LL_USART_FIFOTHRESHOLD_1_8);
  LL_USART_DisableFIFO(USART3);
  LL_USART_ConfigAsyncMode(USART3);
  LL_USART_Enable(USART3);
  /* USER CODE BEGIN USART3_Init 2 */
  /* Clear Overrun flag, in case characters have already been sent to USART */
//  LL_USART_ClearFlag_ORE(USART3);

  /* Enable RXNE and Error interrupts */
//  LL_USART_EnableIT_RXNE(USART3);
//  LL_USART_EnableIT_ERROR(USART3);
  MX_USART3_EnableIT();
//  LL_USART_EnableIT_IDLE(USART3);
//	LL_USART_ClearFlag_IDLE(USART3);
  /* USER CODE END USART3_Init 2 */

}

/* USER CODE BEGIN 1 */

void MX_USART3_EnableIT(void)
{
	/* Enable RXNE and Error interrupts */

	//  LL_USART_EnableIT_ERROR(USART3);
//	LL_USART_ClearFlag_IDLE(USART3);
//	LL_USART_EnableIT_IDLE(USART3);

	LL_USART_EnableIT_RXNE(USART3);

}



void Uart4_SendByte(uint8_t dat)
{
	UNS16 TimeOut = 0xffff;
	while((LL_USART_IsActiveFlag_TC(UART4)!=1) && ( TimeOut--)){};/*wiet*/
	LL_USART_TransmitData8(UART4,dat);
}





void Uart3_SendStr(uint8_t *SendBuf,uint16_t len)
{
	UNS16 TimeOut = 0xffff;
	uint16_t i;
	for(i = 0;i< len;i++)
	{
		while((LL_USART_IsActiveFlag_TC(USART3)!=1) && ( TimeOut--)){};/*wiet*/
		LL_USART_TransmitData8(USART3,*SendBuf++);

		TimeOut = 0xffff;
	}
	//printf("123456");
}

void Uart3_SendByte(uint8_t dat)
{
	UNS16 TimeOut = 0xffff;
	while((LL_USART_IsActiveFlag_TC(USART3)!=1) && ( TimeOut--)){};/*wiet*/
	LL_USART_TransmitData8(USART3,dat);
}


/*test*/
uint8_t flag;
uint8_t state;
uint8_t recv_cnt;
uint16_t header;
uint8_t pkt_len;
void uart3_revice_my_data(void)
{
	uint8_t Res = LL_USART_ReceiveData8(USART3);
	if(flag!=1)
	{
		if(state==0)
		{
			if(Res == 0xfc)
			{
				header = 0x00fc;
			}
			else if(Res ==0xfe)
			{
				header=(header<<8)|Res;
				if(header==0xfcfe)
				{
					state=1;
					USART1_RX_BUF[0]=0xfc;
					USART1_RX_BUF[1]=0xfe;
					recv_cnt=2;
				}
			}
			else
			{
				header=0;
			}
		}
		else if(state==1)
		{
			pkt_len=Res;
			USART1_RX_BUF[recv_cnt++]=pkt_len;
			state=2;
		}
		else if(state==2)
		{
			USART1_RX_BUF[recv_cnt++]=Res;
			if(recv_cnt==pkt_len)
			{
				flag=1;
				state=0;
				recv_cnt=0;
			}
		}
	}
}
/* USER CODE END 1 */
