/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    wwdg.c
  * @brief   This file provides code for the configuration
  *          of the WWDG instances.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "wwdg.h"

/* USER CODE BEGIN 0 */

/*There is no need to go to the window here*/
#define WWDG_COUNTER_VALUE 	127
#define WWDG_WINDOW_VALUE 	127
/*113ms timeout at 4M frequency*/
#define WWDG_REG_REED 		127

const UNS32 WWDG_PRE_TAB[] = {LL_WWDG_PRESCALER_128,LL_WWDG_PRESCALER_128 };
/* USER CODE END 0 */

/* WWDG init function */
void MX_WWDG_Init(void)
{

  /* USER CODE BEGIN WWDG_Init 0 */

  /* USER CODE END WWDG_Init 0 */

  /* Peripheral clock enable */
  LL_APB1_GRP1_EnableClock(LL_APB1_GRP1_PERIPH_WWDG);

  /* USER CODE BEGIN WWDG_Init 1 */

  /* USER CODE END WWDG_Init 1 */
  LL_WWDG_SetCounter(WWDG, WWDG_COUNTER_VALUE);
  LL_WWDG_Enable(WWDG);
  LL_WWDG_SetPrescaler(WWDG, LL_WWDG_PRESCALER_128);
  LL_WWDG_SetWindow(WWDG, WWDG_WINDOW_VALUE);
  /* USER CODE BEGIN WWDG_Init 2 */

  /* USER CODE END WWDG_Init 2 */

}

/* USER CODE BEGIN 1 */
void BSP_FeedWWDG(void)
{
	LL_WWDG_SetCounter(WWDG, WWDG_REG_REED);
}



void MX_WWDG_SET_PRE(UNS8 Inx)
{

  /* USER CODE BEGIN WWDG_Init 0 */

  /* USER CODE END WWDG_Init 0 */

  /* Peripheral clock enable */
  LL_APB1_GRP1_EnableClock(LL_APB1_GRP1_PERIPH_WWDG);

  /* USER CODE BEGIN WWDG_Init 1 */

  /* USER CODE END WWDG_Init 1 */
  LL_WWDG_SetCounter(WWDG, WWDG_COUNTER_VALUE);
  LL_WWDG_Enable(WWDG);
  LL_WWDG_SetPrescaler(WWDG, WWDG_PRE_TAB[Inx]);
  LL_WWDG_SetWindow(WWDG, WWDG_WINDOW_VALUE);
  /* USER CODE BEGIN WWDG_Init 2 */

  /* USER CODE END WWDG_Init 2 */

}
/* USER CODE END 1 */
