/*
 * accel.h
 *
 *  Created on: 2023年12月20日
 *      Author: liuzhimin
 */

#ifndef ACC_ACCEL_H_
#define ACC_ACCEL_H_


//#define ACCEL_IsStatusGood ACC_IsStatusGood

typedef enum {
  ACC_MASTER                  =		0x00,
  ACC_SLAVE			          =		0x01,
  ACC_INT_DATA			      =		0x02,
  ACC_MAX			          =		0x03,
} ACC_CH_E;


typedef struct {
  S16 X;
  S16 Y;
  S16 Z;
} AXIS_DATA_T;

typedef struct {
  S32 X;
  S32 Y;
  S32 Z;
} AXIS_DATA32BIT_T;

void ACC_DataRoutine(void);
BOOL ACCEL_GetDualSensorData(AXIS_DATA_T axis[]);
//BOOL ACCEL_GetDualSensorDataCali(S16* X,S16* Y,S16* Z);
void ACC_InitCalibration(void);
void ACC_CalibrationRoutine(void);
BOOL ACCEL_GetAccelData(S16_PTR const data_x, S16_PTR const data_y, S16_PTR const data_z);
BOOL ACC_ClearSRC(void);
BOOL ACC_IsStatusGood(void);
BOOL ACC_INT_IsStatusGood(void);
BOOL ACC_IsStatusGoodSleep(void);
void ACC_SetDataAccelInit(void);
void ACC_SetSleepMode(UNS8 Switch);

void ACC_RamInit(void);
void ACC_Routine(void);

BOOL ACC_SaveAccOffsetFlash(uint8_t *offset);
BOOL ACC_ReadAccOffsetFlash(uint8_t *offset);
BOOL ACC_SaveAccOffsetReg(uint8_t *offset);
BOOL ACC_ReadAccOffsetReg(uint8_t *offset);

#endif /* ACC_ACCEL_H_ */
