
#include <string.h>
#include "Front.h"
//#include "Side.h"
#include "caw.h"
#ifndef ZERO
#define ZERO 0
#endif
#ifndef ONE
#define ONE 1
#endif
//
#define __CLOSE_REAR_FUN__          (0U)  //xia_update0512
//
#define SDM_CONNECTOR_LEFT		(0U)
#define SDM_CONNECTOR_RIGHT		(1U)
#define SDM_CONNECTOR_FRONT		(3U)
#define SDM_CONNECTOR_REAR		(2U)
//
#define SEGMENT_THRES (1U)
#define TABLE_THRES (0U)
#define Y_ABS (1U)
#define Y_NOT_ABS (0U)
#define ZERO_Dead_Zone (0U)
//
#define THF_MAX_OUT (65535U)
//
///** PUBLIC DATA **/
TAF_GLOBAL_VAR_T TAF;
//
/**	GLOBAL	FUNCTIONS Declare	**/
extern void SDM_45deg_90deg(S16 SDMX, S16 SDMY, S16 * const acux_ptr, S16 * const acuy_ptr);
extern void Data_LPF(S16 input, S32 * const lpf_gain_address, S16 * const lpf_address, UNS8 LPF_Shift);
extern void Data_AMA(S16 input0, S32 * const ama_address, S16 inputn, UNS8 windowsize, UNS8 gain, UNS16 counter);
extern UNS8 Table_Cross_Check(S32 input_x, S32 input_y, UNS8 * const bin_count_address, UNS8 bin_count_length, UNS16 * const bin_size_address, UNS16 * const bin_limit_address, UNS16 * const array_y_address, UNS8 y_abs);
extern UNS8 Segment_Cross_Check(S32 input_x, S32 input_y, UNS16 * const array_x_address, UNS8 array_x_length, UNS16 * const array_y_address, UNS8 segment_or_table, UNS8 y_abs, UNS16 dead_zone);
extern void EDR_Buffer_Refresh(S8 edr, S8 * const buffer_address, UNS8 buffer_length, UNS8 * const  buffer_index_address);
extern void ACU_Buffer_Refresh(S16 edr, S16 * const buffer_address, UNS8 buffer_length, UNS8 * const  buffer_index_address);
extern   S8 Get_EDR_Offset(S8 * const buffer_address, UNS8 buffer_length, UNS8 buffer_index, UNS8 window_size);

/** LOCAL FUNCTION PROTOTYPES **/
static void Bin_Calculate(void);
static void VSensor(S32 input);
static void Deploy_Check(void);
static void High_Level_Deploy_Check(void);
static S16	Abs(S16);
static S32 Power_Sun(S8 * const buffer_address, UNS8 buffer_length);
static S32 Acu_Sun(S16 * const buffer_address, UNS8 buffer_length);
//static void Rear_Deploy_Check(void);
//
UNS8 Bin_Count[3];
/**************************************************************************/
/*  FUNCTION:  TAF_InitializeRam:                                         */
/*                                                                        */
/*                                                                        */
/**************************************************************************/

void TAF_InitializeRam(void)
{
	memset(&(TAF), ZERO, sizeof(TAF));
	Bin_Calculate();
#ifdef ALGO_LOW_TEST_ENABLE
	SDM_INVERT                              =   1;
	FIS_INVERT                              =   1;
	FIS_WINDOWSIZE                          =   4;
	FIS_AMA_GAIN                            =   6;
	VSENSOR_GAIN                            =   9;   //???
	DISP_SHIFT                              =   9;
	VEL_SHIFT                               =   4;
	FRONT_ALGO_ENTRY                        =   3;
	REAR_ALGO_ENTRY                         =   10;
	DEAD_ZONE                               =   3;   //!!!
	VEL_DEAD_ZONE                           =   100; //!!!
	FRONT_ALGO_EXIT_REGION                  =  	50;
	FRONT_ALGO_EXIT_REGION_COUNT            =   30;
	FIS_AMA_ABS                   		 	=	1;
	FRONT_ALGO_MAX_COUNT                    =   1000;
	FRONT_DEPLOY_MIN_COUNT                  =   4;  //default 5 xia_0518;
	FRONT_NEAR_EDR_RECORD_VELOCITY          =   32640;
	FRONT_LOCK_EDR_RECORD_VELOCITY          =   136000;
	FRONT_VELOCITY_KPH_DIVIDE               =   5440;
	ACU_LPF_SHIFT                           =   3;
	FIS_LPF_SHIFT                           =   3;
	ACU_LPF_DIVIDE                          =   20;
	ACUX_EDR_GB_DIVIDE                      =   32;//38:Default_xia0506;
	FIS_LPF_DIVIDE                          =    4;
	SPRING_SWITCH_COUNT                     =    20;
	DISP_1                                  =    11;  //???
	DISP_2                                  =    12;
	DISP_3                                  =    7;
	DISP_4                                  =    8;
	VEL_1                                   =    1; 	//???
	VEL_2                                   =    4;
	VEL_3                                   =    2;
	VEL_4                                   =    4;
	STG2_MAX_DELAY                          =    15;
	STG3_MAX_DELAY                          =    15;
	MU_STG1_N_X[0]                          =    200;
	MU_STG1_N_X[1]                          =    200;
	MU_STG1_N_X[2]	                        =    3000;
	MU_STG1_N_Y[0]                             =    10;
	MU_STG1_N_Y[1]                             =    10;
	MU_STG1_N_Y[2]                             =    50;
	MU_STG1_S_X[0]                             =    250;
	MU_STG1_S_X[1]                             =    340;
	MU_STG1_S_X[2]                             =    340;
	MU_STG1_S_Y[0]                             =    880;
	MU_STG1_S_Y[1]                             =    700;
	MU_STG1_S_Y[2]                             =    700;
	MU_STG2_N_X[0]                             =    900;
	MU_STG2_N_X[1]                             =    900;
	MU_STG2_N_X[2]                             =    900;
	MU_STG2_N_Y[0]                             =    1450;
	MU_STG2_N_Y[1]                             =    1450;
	MU_STG2_N_Y[2]                             =    1450;
	MU_STG2_S_X[0]                             =    200;
	MU_STG2_S_X[1]                             =    300;
	MU_STG2_S_X[2]                             =    780;
	MU_STG2_S_Y[0]                             =    1200;
	MU_STG2_S_Y[1]                             =    1300;
	MU_STG2_S_Y[2]                             =    1400;
	MU_STG3_N_X[0]                             =    65535;
	MU_STG3_N_X[1]                             =    65535;
	MU_STG3_N_X[2]                             =    65535;
	MU_STG3_N_Y[0]                             =    65535;
	MU_STG3_N_Y[1]                             =    65535;
	MU_STG3_N_Y[2]                             =    65535;
	MU_STG3_S_X[0]                             =    65535;
	MU_STG3_S_X[1]                             =    65535;
	MU_STG3_S_X[2]                             =    65535;
	MU_STG3_S_Y[0]                             =    65535;
	MU_STG3_S_Y[1]                             =    65535;
	MU_STG3_S_Y[2]                             =    65535;
	VSEN_S_X[0]                                =    20;
	VSEN_S_X[1]                                =    220;
	VSEN_S_X[2]                                =    470;
	VSEN_S_X[3]                                =    500;
	VSEN_S_X[4]                                =    500;
	VSEN_S_X[5]                                =    500;
	VSEN_S_Y[0]                                =    400;
	VSEN_S_Y[1]                                =    635;
	VSEN_S_Y[2]                                =    940;
	VSEN_S_Y[3]                                =    940;
	VSEN_S_Y[4]                                =    940;
	VSEN_S_Y[5]                                =    940;
	FIS_SWITCH_X[0]                            =    20;
	FIS_SWITCH_X[1]                            =    500;
	FIS_SWITCH_X[2]                            =    1500;
	FIS_SWITCH_X[3]                            =    2800;
	FIS_SWITCH_X[4]                            =    2800;
	FIS_SWITCH_X[5]                            =    2800;
	FIS_SWITCH_Y[0]                            =    1800;
	FIS_SWITCH_Y[1]                            =    3000;
	FIS_SWITCH_Y[2]                            =    3000;
	FIS_SWITCH_Y[3]                            =    3000;
	FIS_SWITCH_Y[4]                            =    3000;
	FIS_SWITCH_Y[5]                            =    3000;
	BINSTARTVSEN                      	      =    20;
	BIN_COUNT[0]                               =    40;
	BIN_COUNT[1]                               =    45;
	BIN_COUNT[2]                               =    28;
	BIN_SIZE[0]                                =  	 64;
	BIN_SIZE[1]                                =  	 128;
	BIN_SIZE[2]                                =  	 128;
	MU_REAR_X[0]                               =    1500;
	MU_REAR_X[1]                               =    1700;
	MU_REAR_X[2]                               =    2000;
	MU_REAR_Y[0]                               =    1600;
	MU_REAR_Y[1]                               =    800;
	MU_REAR_Y[2]                               =    400;
	VSEN_REAR_X[0]                             =    20;
	VSEN_REAR_X[1]                             =    148;
	VSEN_REAR_X[2]                             =    372;
	VSEN_REAR_X[3]                             =    756;
	VSEN_REAR_X[4]                             =    1012;
	VSEN_REAR_X[5]                             =    1748;
	VSEN_REAR_Y[0]                             =    800;
	VSEN_REAR_Y[1]                             =    800;
	VSEN_REAR_Y[2]                             =    800;
	VSEN_REAR_Y[3]                             =    800;
	VSEN_REAR_Y[4]                             =    800;
	VSEN_REAR_Y[5]                             =    800;
	VSEN_N[0]                                  =    550;
	VSEN_N[1]                                  =    700;
	VSEN_N[2]                                  =    680;
	VSEN_N[3]                                  =    640;
	VSEN_N[4]                                  =    730;
	VSEN_N[5]                                  =    1800;
	VSEN_N[6]                                  =    1800;
	VSEN_N[7]                                  =    1800;
	VSEN_N[8]                                  =    1800;
	VSEN_N[9]                                  =    1800;
	VSEN_N[10]                                  =   1400;
	VSEN_N[11]                                  =    1400;
	VSEN_N[12]                                  =    1400;
	VSEN_N[13]                                  =    1400;
	VSEN_N[14]                                  =    1300;
	VSEN_N[15]                                  =    1400;
	VSEN_N[16]                                  =    3710;
	VSEN_N[17]                                  =    720;
	VSEN_N[18]                                  =    520;
	VSEN_N[19]                                  =    520;
	VSEN_N[20]                                  =    520;
	VSEN_N[21]                                  =    520;
	VSEN_N[22]                                  =    520;
	VSEN_N[23]                                  =    520;
	VSEN_N[24]                                  =    520;
	VSEN_N[25]                                  =    520;
	VSEN_N[26]                                  =    520;
	VSEN_N[27]                                  =    520;
	VSEN_N[28]                                  =    520;
	VSEN_N[29]                                  =    520;
	VSEN_N[30]                                  =    520;
	VSEN_N[31]                                  =    520;
	VSEN_N[32]                                  =    520;
	VSEN_N[33]                                  =    520;
	VSEN_N[34]                                  =    520;
	VSEN_N[35]                                  =    520;
	VSEN_N[36]                                  =    520;
	VSEN_N[37]                                  =    520;
	VSEN_N[38]                                  =    520;
	VSEN_N[39]                                  =    520;
	VSEN_N[40]                                  =    520;
	VSEN_N[41]                                  =    520;
	VSEN_N[42]                                  =    520;
	VSEN_N[43]                                  =    520;
	VSEN_N[44]                                  =    520;
	VSEN_N[45]                                  =    520;
	VSEN_N[46]                                  =    1350;
	VSEN_N[47]                                  =    1350;
	VSEN_N[48]                                  =    1350;
	VSEN_N[49]                                  =    1350;
	VSEN_N[50]                                  =    1350;
	VSEN_N[51]                                  =    1350;
	VSEN_N[52]                                  =    1350;
	VSEN_N[53]                                  =    1350;
	VSEN_N[54]                                  =    1800;
	VSEN_N[55]                                  =    1800;
	VSEN_N[56]                                  =    1800;
	VSEN_N[57]                                  =    1800;
	VSEN_N[58]                                  =    1800;
	VSEN_N[59]                                  =    1800;
	VSEN_N[60]                                  =    1800;
	VSEN_N[61]                                  =    1800;
	VSEN_N[62]                                  =    1800;
	VSEN_N[63]                                  =    1800;
	VSEN_N[64]                                  =    1800;
	VSEN_N[65]                                  =    1800;
	VSEN_N[66]                                  =    1800;
	VSEN_N[67]                                  =    1800;
	VSEN_N[68]                                  =    1800;
	VSEN_N[69]                                  =    1800;
	VSEN_N[70]                                  =    1800;
	VSEN_N[71]                                  =    1800;
	VSEN_N[72]                                  =    1800;
	VSEN_N[73]                                  =    1800;
	VSEN_N[74]                                  =    1800;
	VSEN_N[75]                                  =    1800;
	VSEN_N[76]                                  =    1800;
	VSEN_N[77]                                  =    1800;
	VSEN_N[78]                                  =    1800;
	VSEN_N[79]                                  =    1800;
	VSEN_N[80]                                  =    1800;
	VSEN_N[81]                                  =    1800;
	VSEN_N[82]                                  =    1800;
	VSEN_N[83]                                  =    1800;
	VSEN_N[84]                                  =    1800;
	VSEN_N[85]                                  =    1800;
	VSEN_N[86]                                  =    1800;
	VSEN_N[87]                                  =    1800;
	VSEN_N[88]                                  =    1800;
	VSEN_N[89]                                  =    1800;
	VSEN_N[90]                                  =    1800;
	VSEN_N[91]                                  =    1800;
	VSEN_N[92]                                  =    1800;
	VSEN_N[93]                                  =    1800;
	VSEN_N[94]                                  =    1800;
	VSEN_N[95]                                  =    1800;
	VSEN_N[96]                                  =    1800;
	VSEN_N[97]                                  =    1800;
	VSEN_N[98]                                  =    1800;
	VSEN_N[99]                                  =    1800;

#else
	SDM_INVERT                              =   1;
	FIS_INVERT                              =   1;
	FIS_WINDOWSIZE                          =   4;
	FIS_AMA_GAIN                            =   6;
	VSENSOR_GAIN                            =   10;   //???
	DISP_SHIFT                              =   9;
	VEL_SHIFT                               =   3;
	FRONT_ALGO_ENTRY                        =   2;
	REAR_ALGO_ENTRY                         =   10;
	DEAD_ZONE                               =   3;   //!!!
	VEL_DEAD_ZONE                           =   100; //!!!
	FRONT_ALGO_EXIT_REGION                  =  	50;
	FRONT_ALGO_EXIT_REGION_COUNT            =   30;
	FIS_AMA_ABS                   		 	=	1;
	FRONT_ALGO_MAX_COUNT                    =   200;
	FRONT_DEPLOY_MIN_COUNT                  =   3;  //default 5 xia_0518;
	FRONT_NEAR_EDR_RECORD_VELOCITY          =   32640;
	FRONT_LOCK_EDR_RECORD_VELOCITY          =   136000;
	FRONT_VELOCITY_KPH_DIVIDE               =   5440;
	ACU_LPF_SHIFT                           =   8;
	FIS_LPF_SHIFT                           =   8;
	ACU_LPF_DIVIDE                          =   20;
	ACUX_EDR_GB_DIVIDE                      =   32;//38:Default_xia0506;
	FIS_LPF_DIVIDE                          =    20; //use RFIS replace NAVI_AUCY
	SPRING_SWITCH_COUNT                     =    20;
	DISP_1                                  =    11;
	DISP_2                                  =    9;
	DISP_3                                  =    7;
	DISP_4                                  =    8;
	VEL_1                                   =    1;
	VEL_2                                   =    3;
	VEL_3                                   =    2;
	VEL_4                                   =    4;
	STG2_MAX_DELAY                          =    15;
	STG3_MAX_DELAY                          =    15;
	MU_STG1_N_X[0]                          =    2500;
	MU_STG1_N_X[1]                          =    4000;
	MU_STG1_N_X[2]	                        =    65535;
	MU_STG1_N_Y[0]                             =    2600;
	MU_STG1_N_Y[1]                             =    2000;
	MU_STG1_N_Y[2]                             =    7000;
	MU_STG1_S_X[0]                             =    100;
	MU_STG1_S_X[1]                             =    600;
	MU_STG1_S_X[2]                             =    3000;
	MU_STG1_S_Y[0]                             =    4000;
	MU_STG1_S_Y[1]                             =    2000;
	MU_STG1_S_Y[2]                             =    5400;
	MU_STG2_N_X[0]                             =    900;
	MU_STG2_N_X[1]                             =    900;
	MU_STG2_N_X[2]                             =    900;
	MU_STG2_N_Y[0]                             =    1450;
	MU_STG2_N_Y[1]                             =    1450;
	MU_STG2_N_Y[2]                             =    1450;
	MU_STG2_S_X[0]                             =    200;
	MU_STG2_S_X[1]                             =    300;
	MU_STG2_S_X[2]                             =    780;
	MU_STG2_S_Y[0]                             =    1200;
	MU_STG2_S_Y[1]                             =    1300;
	MU_STG2_S_Y[2]                             =    1400;
	MU_STG3_N_X[0]                             =    65535;
	MU_STG3_N_X[1]                             =    65535;
	MU_STG3_N_X[2]                             =    65535;
	MU_STG3_N_Y[0]                             =    65535;
	MU_STG3_N_Y[1]                             =    65535;
	MU_STG3_N_Y[2]                             =    65535;
	MU_STG3_S_X[0]                             =    65535;
	MU_STG3_S_X[1]                             =    65535;
	MU_STG3_S_X[2]                             =    65535;
	MU_STG3_S_Y[0]                             =    65535;
	MU_STG3_S_Y[1]                             =    65535;
	MU_STG3_S_Y[2]                             =    65535;
	VSEN_S_X[0]                                =    20;
	VSEN_S_X[1]                                =    550;
	VSEN_S_X[2]                                =    650;
	VSEN_S_X[3]                                =    800;
	VSEN_S_X[4]                                =    1600;
	VSEN_S_X[5]                                =    3000;
	VSEN_S_Y[0]                                =    4200;
	VSEN_S_Y[1]                                =    2200;
	VSEN_S_Y[2]                                =    3600;
	VSEN_S_Y[3]                                =    6000;
	VSEN_S_Y[4]                                =    6000;
	VSEN_S_Y[5]                                =    6000;
	FIS_SWITCH_X[0]                            =    20;
	FIS_SWITCH_X[1]                            =    500;
	FIS_SWITCH_X[2]                            =    1000;
	FIS_SWITCH_X[3]                            =    2800;
	FIS_SWITCH_X[4]                            =    3800;
	FIS_SWITCH_X[5]                            =    4500;
	FIS_SWITCH_Y[0]                            =    4200;
	FIS_SWITCH_Y[1]                            =    2200;
	FIS_SWITCH_Y[2]                            =    5000;
	FIS_SWITCH_Y[3]                            =    5500;
	FIS_SWITCH_Y[4]                            =    6000;
	FIS_SWITCH_Y[5]                            =    6000;
	MU_PWR_S_X[0]                            =    27;
	MU_PWR_S_X[1]                            =    65;
	MU_PWR_S_X[2]                            =    150;
	MU_PWR_S_X[3]                            =    65535;
	MU_PWR_S_Y[0]                            =    80;
	MU_PWR_S_Y[1]                            =    200;
	MU_PWR_S_Y[2]                            =    105;
	MU_PWR_S_Y[3]                            =    65535;
	BINSTARTVSEN                      	       =    20;
	BIN_COUNT[0]                               =    60;
	BIN_COUNT[1]                               =    45;
	BIN_COUNT[2]                               =    28;
	BIN_SIZE[0]                                =  	40;
	BIN_SIZE[1]                                =  	128;
	BIN_SIZE[2]                                =  	128;
	MU_REAR_X[0]                               =    1500;
	MU_REAR_X[1]                               =    1700;
	MU_REAR_X[2]                               =    2000;
	MU_REAR_Y[0]                               =    1600;
	MU_REAR_Y[1]                               =    800;
	MU_REAR_Y[2]                               =    400;
	VSEN_REAR_X[0]                             =    20;
	VSEN_REAR_X[1]                             =    148;
	VSEN_REAR_X[2]                             =    372;
	VSEN_REAR_X[3]                             =    756;
	VSEN_REAR_X[4]                             =    1012;
	VSEN_REAR_X[5]                             =    1748;
	VSEN_REAR_Y[0]                             =    800;
	VSEN_REAR_Y[1]                             =    800;
	VSEN_REAR_Y[2]                             =    800;
	VSEN_REAR_Y[3]                             =    800;
	VSEN_REAR_Y[4]                             =    800;
	VSEN_REAR_Y[5]                             =    800;
	VSEN_N[0]                                  =    4200;
	VSEN_N[1]                                  =    4000;
	VSEN_N[2]                                  =    4000;
	VSEN_N[3]                                  =    4000;
	VSEN_N[4]                                  =    2800;
	VSEN_N[5]                                  =    2900;
	VSEN_N[6]                                  =    2600;
	VSEN_N[7]                                  =    2600;
	VSEN_N[8]                                  =    3300;
	VSEN_N[9]                                  =    3300;
	VSEN_N[10]                                  =   4000;
	VSEN_N[11]                                  =    4000;
	VSEN_N[12]                                  =    5500;
	VSEN_N[13]                                  =    5500;
	VSEN_N[14]                                  =   4500;
	VSEN_N[15]                                  =    5500;
	VSEN_N[16]                                  =    5500;
	VSEN_N[17]                                  =    5500;
	VSEN_N[18]                                  =    5500;
	VSEN_N[19]                                  =    5500;
	VSEN_N[20]                                  =    5500;
	VSEN_N[21]                                  =    5500;
	VSEN_N[22]                                  =    5500;
	VSEN_N[23]                                  =    5500;
	VSEN_N[24]                                  =    4000;
	VSEN_N[25]                                  =    4000;
	VSEN_N[26]                                  =    4000;
	VSEN_N[27]                                  =    4000;
	VSEN_N[28]                                  =    5000;
	VSEN_N[29]                                  =    5000;
	VSEN_N[30]                                  =    5000;
	VSEN_N[31]                                  =    5000;
	VSEN_N[32]                                  =    5000;
	VSEN_N[33]                                  =    5000;
	VSEN_N[34]                                  =    5000;
	VSEN_N[35]                                  =    5000;
	VSEN_N[36]                                  =    5000;
	VSEN_N[37]                                  =    4500;
	VSEN_N[38]                                  =    4500;
	VSEN_N[39]                                  =    4500;
	VSEN_N[40]                                  =    4500;
	VSEN_N[41]                                  =    4500;
	VSEN_N[42]                                  =    4500;
	VSEN_N[43]                                  =    4500;
	VSEN_N[44]                                  =    4500;
	VSEN_N[45]                                  =    4000;
	VSEN_N[46]                                  =    4200;
	VSEN_N[47]                                  =    1000;
	VSEN_N[48]                                  =    1000;
	VSEN_N[49]                                  =    1000;
	VSEN_N[50]                                  =    1000;
	VSEN_N[51]                                  =    1000;
	VSEN_N[52]                                  =    1000;
	VSEN_N[53]                                  =    1000;
	VSEN_N[54]                                  =    1000;
	VSEN_N[55]                                  =    1000;
	VSEN_N[56]                                  =    1000;
	VSEN_N[57]                                  =    1000;
	VSEN_N[58]                                  =    1000;
	VSEN_N[59]                                  =    1000;
	VSEN_N[60]                                  =    1000;
	VSEN_N[61]                                  =    1000;
	VSEN_N[62]                                  =    1000;
	VSEN_N[63]                                  =    1000;
	VSEN_N[64]                                  =    4000;
	VSEN_N[65]                                  =    4000;
	VSEN_N[66]                                  =    4000;
	VSEN_N[67]                                  =    4000;
	VSEN_N[68]                                  =    4000;
	VSEN_N[69]                                  =    4000;
	VSEN_N[70]                                  =    4000;
	VSEN_N[71]                                  =    4000;
	VSEN_N[72]                                  =    4000;
	VSEN_N[73]                                  =    4000;
	VSEN_N[74]                                  =    4000;
	VSEN_N[75]                                  =    4000;
	VSEN_N[76]                                  =    4000;
	VSEN_N[77]                                  =    4000;
	VSEN_N[78]                                  =    4000;
	VSEN_N[79]                                  =    4000;
	VSEN_N[80]                                  =    4000;
	VSEN_N[81]                                  =    4000;
	VSEN_N[82]                                  =    4000;
	VSEN_N[83]                                  =    4000;
	VSEN_N[84]                                  =    4000;
	VSEN_N[85]                                  =    4000;
	VSEN_N[86]                                  =    4000;
	VSEN_N[87]                                  =    4000;
	VSEN_N[88]                                  =    4000;
	VSEN_N[89]                                  =    4000;
	VSEN_N[90]                                  =    4000;
	VSEN_N[91]                                  =    4000;
	VSEN_N[92]                                  =    4000;
	VSEN_N[93]                                  =    4000;
	VSEN_N[94]                                  =    4000;
	VSEN_N[95]                                  =    4000;
	VSEN_N[96]                                  =    4000;
	VSEN_N[97]                                  =    4000;
	VSEN_N[98]                                  =    4000;
	VSEN_N[99]                                  =    4000;
	PWRALG_RESET_LIMIT							= 30;
#endif
	CALIB_FROM.Data.CrashEnable.CrashEnableAlg.EnableFrontCrash = TRUE;
}

S16 acc_xtab[1000] = {0};
S16 acc_ytab[1000] = {0};
UNS16 acc_inx =0;
UNS16 acc_inx1 =0;
S16 ACUX_Bake = 0.0;
S16 ACUY_Bake = 0.0;
S16 ACUX_LEVEL_EDR_BUFFER[10] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
UNS16 ACUX_LEVEL_EDR_BUFFER_LENGTH = 5;  //5ms windows
UNS8 ACUX_LEVEL_EDR_BUFFER_INDEX = 1;
S32 ACUX_LEVEL = 0.0;
/**************************************************************************/
/*  FUNCTION:  TAF_Algo:                                                  */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
void TAF_Algo(S16 SDMX, S16 SDMY,S16 SDMZ, S16 LFIS, S16 RFIS)
{
	S16 ACUX;
	S16 ACUY;
	S32 power_temp = 0;

	//SDM_45deg_90deg(SDMX, SDMY, &ACUX, &ACUY);
	ACUX = SDMX;
	ACUY = SDMY;
	//FIS polarity

	if(FIS_INVERT==1U)
	{
		LFIS=-LFIS;
		RFIS=-RFIS;
	}
	else if(FIS_INVERT==0U)
	{
		//do nothing
	}
	else//not defined, set to 0
	{
		LFIS=ZERO;
		RFIS=ZERO;
	}



	if(Abs(ACUY_Bake) >= 25)
   	{
   		if(Abs(ACUY) > (Abs(ACUY_Bake) * 6))
   			ACUY = (ACUY_Bake + ACUY)/2;
   	}
    else if((Abs(ACUY_Bake) >= 1)&& ((Abs(ACUY_Bake) < 10)))
   	{
   		if(Abs(ACUY) > (Abs(ACUY_Bake) * 200))
   			ACUY = (ACUY_Bake + ACUY)/2;
   	}
    else if((Abs(ACUY_Bake) >= 10)&& ((Abs(ACUY_Bake) < 25)))
    {
    	if(Abs(ACUY) > (Abs(ACUY_Bake) * 50))
    		ACUY = (ACUY_Bake + ACUY)/2;
    }
    else if ((ACUY - ACUY_Bake)> 600)
    {
    	ACUY = (ACUY_Bake + ACUY)/2;
    }
    else
    {
    	ACUY_Bake  = ACUY;
    }
    ACUY_Bake  = ACUY;


//	if(Abs(ACUX_Bake) >= 25)
//	{
//		if(Abs(ACUX) > (Abs(ACUX_Bake) * 6))
//			ACUX = (ACUX_Bake + ACUX)/2;
//
//	}
//	else if((Abs(ACUX_Bake) >= 1)&& ((Abs(ACUX_Bake) < 10)))
//	{
//		if(Abs(ACUX) > (Abs(ACUX_Bake) * 200))
//			ACUX = (ACUX_Bake + ACUX)/3;
//
//	}
//	else if((Abs(ACUX_Bake) >= 10)&& ((Abs(ACUX_Bake) < 25)))
//	{
//		if(Abs(ACUX) > (Abs(ACUX_Bake) * 60))
//			ACUX = (ACUX_Bake + ACUX)/2;
//	}
//	else if ((ACUX - ACUX_Bake)> 600)
//    {
//		ACUX = (ACUX_Bake + ACUX)/2;
//    }
//    else
//    {
//         ACUX_Bake  = ACUX;
//    }
//	ACUX_Bake  = ACUX;
    /*********************************/


	//##ACUX LPF####################
	Data_LPF(ACUX, &ACUX_LPF_GAIN, &ACUX_LPF, ACU_LPF_SHIFT);
	Data_LPF(ACUY, &ACUY_LPF_GAIN, &ACUY_LPF, ACU_LPF_SHIFT);
	Data_LPF(LFIS, &LFIS_LPF_GAIN, &LFIS_LPF, FIS_LPF_SHIFT);
	Data_LPF(-ACUY, &RFIS_LPF_GAIN, &RFIS_LPF, FIS_LPF_SHIFT);		//use RFIS replace NAVI_AUCY

//	FLASH_StorageACC(ACUX, ACUY);//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


	if(FRONT_ALGO_1MS_COUNTER==0U)
	{
		FRONT_ALGO_1MS_COUNTER=ONE;
#if CAN_GET_ACCEL_DEBUG
		ACUX_LPF_EDR=ACUX_LPF;
#else
		ACUX_LPF_EDR = Divide_To_8bit(ACUX_LPF, ONE, ACU_LPF_DIVIDE, ZERO, EDR_8_BIT_MAX, EDR_8_BIT_MIN);
		ACUY_LPF_EDR = Divide_To_8bit(ACUY_LPF, ONE, ACU_LPF_DIVIDE, ZERO, EDR_8_BIT_MAX, EDR_8_BIT_MIN);
		LFIS_LPF_EDR = Divide_To_8bit(LFIS_LPF, ONE, FIS_LPF_DIVIDE, ZERO, EDR_8_BIT_MAX, EDR_8_BIT_MIN);
		RFIS_LPF_EDR = Divide_To_8bit(RFIS_LPF, ONE, FIS_LPF_DIVIDE, ZERO, EDR_8_BIT_MAX, EDR_8_BIT_MIN); //use RFIS replace NAVI_AUCY

#endif


		EDR_Buffer_Refresh(ACUX_LPF_EDR, ACUX_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, &ACUX_LPF_EDR_BUFFER_INDEX);
		EDR_Buffer_Refresh(ACUY_LPF_EDR, ACUY_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, &ACUY_LPF_EDR_BUFFER_INDEX);
		EDR_Buffer_Refresh(ACUX_LPF_EDR, LFIS_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, &LFIS_LPF_EDR_BUFFER_INDEX); 
		EDR_Buffer_Refresh(RFIS_LPF_EDR, RFIS_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, &RFIS_LPF_EDR_BUFFER_INDEX);//use RFIS replace ACUX

		//DebugMessageFromCan(0x301, ACUX_LPF_EDR);

		if((FRONT_ALGO_ON==0U)&&(FRONT_ALGO_ENTERED_COUNTER<FRONT_ALGO_MAX_COUNT)&&((ACUX_LPF_EDR>=(S16)FRONT_ALGO_ENTRY)||(ACUX_LPF_EDR<=-(S16)REAR_ALGO_ENTRY)))
		{
			//缂佺姵顨嗙涵鍫曟焻閳ь剟宕欐潪鎵憹婵炴挸鎳樺ù鍌炴晬瀹€鍐闁稿繈鍎插鍌炲磹濞嗗繐鏅欐繛鎿勬嫹
			FRONT_DECISION_LEVEL[0]=ZERO;
			FRONT_DECISION_LEVEL[1]=ZERO;
			FRONT_DECISION_LEVEL[2]=ZERO;
			REAR_DEPLOY=ZERO;
			FRONT_ALGO_ON=ONE;
			FRONT_ALGO_ENTERED_COUNTER=ZERO;
			PWR_ALGO_ENTERED_COUNTER = ZERO;
			FRONT_DELTA_VELOCITY=DELTA_V_BUFFER*2*ACU_LPF_DIVIDE;	//DELTA_V_BUFFER default is ZERO
//			DebugMessageFromCan(0x302, REAR_DEPLOY);
		}
		if(FRONT_ALGO_ON==1U)//Algo Activated
		{

			S8 LFIS_EDR_Offset=Get_EDR_Offset(LFIS_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, LFIS_LPF_EDR_BUFFER_INDEX, FIS_WINDOWSIZE);
			S8 ACUY_EDR_Offset=Get_EDR_Offset(ACUY_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, RFIS_LPF_EDR_BUFFER_INDEX, FIS_WINDOWSIZE);
			S8 RFIS_EDR_Offset=Get_EDR_Offset(RFIS_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, RFIS_LPF_EDR_BUFFER_INDEX, FIS_WINDOWSIZE);
			FRONT_ALGO_ENTERED_COUNTER++;
			if(((DISP_FINAL>=ZERO)&&(VEL_FINAL<ZERO))||((DISP_FINAL<ZERO)&&(VEL_FINAL>=ZERO)))
			{//閻犱緤绱曢悾缁樻交閸モ斁鏌?
				if(SPRING_SWITCH_COUNTER<SPRING_SWITCH_COUNT)
				{
					SPRING_SWITCH_COUNTER++;
				}
			}
			else
			{//缂佹鍏涚粩鏉戔枎闄囬鍝ョ不閿燂拷
				SPRING_SWITCH_COUNTER=ZERO;
			}
			VSensor(ACUX_LPF_EDR);

			 ACUX_POWER = Power_Sun(LFIS_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH)- Abs(LFIS_EDR_Offset);

			 power_temp  = Power_Sun(ACUY_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH)- Abs(ACUY_EDR_Offset); //record  Y POWER MAX
			 //if(ACUY_POWER < power_temp)
				 ACUY_POWER = power_temp;

			 power_temp = Power_Sun(RFIS_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH)- Abs(RFIS_EDR_Offset); //record  Y POWER MAX

			 NAVI_ACUY_POWER = power_temp;




			 PWR_ALGO_ENTERED_COUNTER = PWR_ALGO_ENTERED_COUNTER + 1;


			Data_AMA(ACUX_LPF_EDR, &LFIS_AMA, LFIS_EDR_Offset, FIS_WINDOWSIZE, FIS_AMA_GAIN, FRONT_ALGO_ENTERED_COUNTER);
			//Data_AMA(RFIS_LPF_EDR, &RFIS_AMA, RFIS_EDR_Offset, FIS_WINDOWSIZE, FIS_AMA_GAIN, FRONT_ALGO_ENTERED_COUNTER);
			FRONT_DELTA_VELOCITY=ACUX_LPF+FRONT_DELTA_VELOCITY;
			if(VSEN_N_CROSSED==0U)
			{
				VSEN_N_CROSSED=Table_Cross_Check(DISP_FINAL,VEL_FINAL,BIN_COUNT,BIN_COUNT_LENGTH,BIN_SIZE,BIN_LIMIT,VSEN_N,Y_NOT_ABS);
			}
			if(VSEN_S_CROSSED==0U)
			{
				VSEN_S_CROSSED=Segment_Cross_Check(DISP_FINAL,VEL_FINAL,VSEN_S_X,VSEN_S_X_LENGTH,VSEN_S_Y,SEGMENT_THRES,Y_NOT_ABS,ZERO_Dead_Zone);
			}
			MU_STG1_N_CROSSED=Segment_Cross_Check(DISP_FINAL,VEL_FINAL,MU_STG1_N_X,MU_STG1_N_X_LENGTH,MU_STG1_N_Y,SEGMENT_THRES,Y_NOT_ABS,VEL_DEAD_ZONE);
			MU_STG1_S_CROSSED=Segment_Cross_Check(DISP_FINAL,VEL_FINAL,MU_STG1_S_X,MU_STG1_S_X_LENGTH,MU_STG1_S_Y,SEGMENT_THRES,Y_NOT_ABS,VEL_DEAD_ZONE);
			if(VEL_FINAL>ZERO)
			{
				if(FIS_SWITCH_CROSSED==0U)
				{
					FIS_SWITCH_CROSSED=Segment_Cross_Check(DISP_FINAL,LFIS_AMA,FIS_SWITCH_X,FIS_SWITCH_X_LENGTH,FIS_SWITCH_Y,SEGMENT_THRES,FIS_AMA_ABS,ZERO_Dead_Zone);
				}
				if(FIS_SWITCH_CROSSED==0U)
				{
				//	FIS_SWITCH_CROSSED=Segment_Cross_Check(DISP_FINAL,RFIS_AMA,FIS_SWITCH_X,FIS_SWITCH_X_LENGTH,FIS_SWITCH_Y,SEGMENT_THRES,FIS_AMA_ABS,ZERO_Dead_Zone);
				}
			}

			 PWR_SWITCH_CROSSED=Segment_Cross_Check(PWR_ALGO_ENTERED_COUNTER,ACUX_POWER,MU_PWR_S_X,MU_PWR_S_X_LENGTH,MU_PWR_S_Y,SEGMENT_THRES,0,ZERO_Dead_Zone);

//			if(((ACUX_POWER * 1.6) > ACUY_POWER) && (((ACUX_POWER * 1.6) > NAVI_ACUY_POWER)))
//			{
				if((ACUX_POWER > (ACUY_POWER*1.1)) && (ACUX_POWER > (NAVI_ACUY_POWER*1.1)))
					Deploy_Check();
//			}
			else if(ACUX_POWER > 200)
				Deploy_Check();

			if((DISP_FINAL<=(S32)FRONT_ALGO_EXIT_REGION)&&(DISP_FINAL>=-(S32)FRONT_ALGO_EXIT_REGION)&&(FRONT_ALGO_ENTERED_COUNTER>150))
			{
				if(FLAG_ALREADY_RESET==0U)
				{
					FLAG_ALREADY_RESET=ONE;
					memset(&(TAF.Reset_After_Force_Exit.Reset_After_Exit.Flag_Reset), ZERO, sizeof(TAF_FLAG_RESET_VAR_T));
				}
			}
			else
			{
				FLAG_ALREADY_RESET=ZERO;
			}
			if((DISP_FINAL<=(S32)FRONT_ALGO_EXIT_REGION)&&(DISP_FINAL>=-(S32)FRONT_ALGO_EXIT_REGION)&&(VEL_FINAL<=(S32)FRONT_ALGO_EXIT_REGION)&&(VEL_FINAL>=-(S32)FRONT_ALGO_EXIT_REGION)&&(FRONT_ALGO_ENTERED_COUNTER>150))
			{
				FRONT_ALGO_EXIT_REGION_COUNTER++;
			}
			else
			{
				FRONT_ALGO_EXIT_REGION_COUNTER=ZERO;
			}
			if(FRONT_ALGO_EXIT_REGION_COUNTER>=FRONT_ALGO_EXIT_REGION_COUNT)
			{
				memset(&(TAF.Reset_After_Force_Exit.Reset_After_Exit), ZERO, sizeof(TAF_RESET_AFTER_EXIT_VAR_T));
			}
			if(FRONT_ALGO_ENTERED_COUNTER>=FRONT_ALGO_MAX_COUNT)
			{
				memset(&(TAF.Reset_After_Force_Exit), ZERO, sizeof(TAF_RESET_AFTER_FORCE_EXIT_VAR_T));
				ACUX_Bake = 0.0;
				ACUY_Bake = 0.0;
			}
		}

	}
	else
	{
		FRONT_ALGO_1MS_COUNTER=ZERO;
		if(FRONT_ALGO_ON==1U)
		{
			FRONT_DELTA_VELOCITY=ACUX_LPF+FRONT_DELTA_VELOCITY;

			if(FRONT_DECISION_LEVEL[0]==1U)
			{
				STG2_DELAY_COUNTER++;
				MU_STG2_N_CROSSED=Segment_Cross_Check(DISP_FINAL,VEL_FINAL,MU_STG2_N_X,MU_STG2_N_X_LENGTH,MU_STG2_N_Y,SEGMENT_THRES,Y_NOT_ABS,VEL_DEAD_ZONE);
				MU_STG2_S_CROSSED=Segment_Cross_Check(DISP_FINAL,VEL_FINAL,MU_STG2_S_X,MU_STG2_S_X_LENGTH,MU_STG2_S_Y,SEGMENT_THRES,Y_NOT_ABS,VEL_DEAD_ZONE);
			}
			if(FRONT_DECISION_LEVEL[1]==1U)
			{
				STG3_DELAY_COUNTER++;
				MU_STG3_N_CROSSED=Segment_Cross_Check(DISP_FINAL,VEL_FINAL,MU_STG3_N_X,MU_STG3_N_X_LENGTH,MU_STG3_N_Y,SEGMENT_THRES,Y_NOT_ABS,VEL_DEAD_ZONE);
				MU_STG3_S_CROSSED=Segment_Cross_Check(DISP_FINAL,VEL_FINAL,MU_STG3_S_X,MU_STG3_S_X_LENGTH,MU_STG3_S_Y,SEGMENT_THRES,Y_NOT_ABS,VEL_DEAD_ZONE);
			}
#if __CLOSE_REAR_FUN__
			MU_REAR_CROSSED=Segment_Cross_Check(-DISP_FINAL,-VEL_FINAL,MU_REAR_X,MU_REAR_X_LENGTH,MU_REAR_Y,SEGMENT_THRES,Y_NOT_ABS,VEL_DEAD_ZONE);
			if(VSEN_REAR_CROSSED==0U)
			{
				VSEN_REAR_CROSSED=Segment_Cross_Check(-DISP_FINAL,-VEL_FINAL,VSEN_REAR_X,VSEN_REAR_X_LENGTH,VSEN_REAR_Y,TABLE_THRES,Y_NOT_ABS,ZERO_Dead_Zone);
			}
#endif
		//High_Level_Deploy_Check();
#if __CLOSE_REAR_FUN__
			Rear_Deploy_Check();
#endif

		}
		else//缂佺姵顨嗙涵璺衡柦閳ヨ櫕韬弶鈺傚姌椤㈡垿寮敓锟?
		{
			S8 ACUX_LPF_EDR_Offset_ForVel=Get_EDR_Offset(ACUX_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, ACUX_LPF_EDR_BUFFER_INDEX, FRONT_EDR_BUFFER_LENGTH-1);
			DELTA_V_BUFFER=DELTA_V_BUFFER+ACUX_LPF_EDR-ACUX_LPF_EDR_Offset_ForVel;
		}
	}
}  /* TAF_Algo */

/**************************************************************************/
/*  FUNCTION:  Bin_Calculate                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
static void Bin_Calculate(void)
{
	UNS8 i;
	BIN_LIMIT[0]=BINSTARTVSEN;
	for(i=1;i<=BIN_COUNT_LENGTH;i++)
	{
		BIN_LIMIT[i]=BIN_COUNT[i-1]*BIN_SIZE[i-1];
	}

}  /* Bin_Calculate */
///**************************************************************************/
///*  FUNCTION:  SDM_45deg_90deg:                                         */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
void SDM_45deg_90deg(S16 SDMX, S16 SDMY, S16 * const acux_ptr, S16 * const acuy_ptr)
{
	if(SDM_INVERT==SDM_CONNECTOR_LEFT)//EG闁规亽鍎茶ぐ鍐╃閼稿灚绡傜€归潻鎷?
	{
		*acux_ptr=SDMX-SDMY;
		*acuy_ptr=SDMX+SDMY;
	}
	else if(SDM_INVERT==SDM_CONNECTOR_RIGHT)//EG闁规亽鍎茶ぐ鍐╃閼稿灚绡傞柛娆欐嫹
	{
		*acux_ptr=SDMY-SDMX;
		*acuy_ptr=-SDMX-SDMY;
	}
	else if(SDM_INVERT==SDM_CONNECTOR_REAR)//EG闁规亽鍎茶ぐ鍐╃閼稿灚绡傚☉鎿勬嫹
	{
		*acux_ptr=SDMX+SDMY;
		*acuy_ptr=-SDMX+SDMY;
	}
	else if(SDM_INVERT==SDM_CONNECTOR_FRONT)//EG闁规亽鍎茶ぐ鍐╃閼稿灚绡傚☉鎿勬嫹
	{
		*acux_ptr=-SDMX-SDMY;
		*acuy_ptr=SDMX-SDMY;
	}
	else
	{
		*acux_ptr=ZERO;
		*acuy_ptr=ZERO;
	}
}  /* SDM_45deg_90deg */

/**************************************************************************/
/*  FUNCTION:  LPF                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
void Data_LPF(S16 input, S32 * const lpf_gain_address, S16 * const lpf_address, UNS8 LPF_Shift)
{
	*lpf_gain_address=input+*lpf_gain_address-(*lpf_gain_address/LPF_Shift);//闁跨喐鏋婚幏鐑芥晸閺傘倖瀚归柨鐔峰鐠囇勫LPF_Shift==3闁跨喐纾ヨぐ鎾绘晸閺傘倖瀚归崣锟?闁跨喐鏋婚幏宄伴挬闁跨喐鏋婚幏锟?
	*lpf_address=*lpf_gain_address/LPF_Shift;
}
//*lpf_gain_address=ACUX+*lpf_gain_address-(*lpf_gain_address>>3);
//ACUX_LPF=(ACUX+*lpf_gain_address-(*lpf_gain_address>>3))>>3;
/**************************************************************************/
/*  FUNCTION:  TAF_EDR_Buffer_Refresh                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
void EDR_Buffer_Refresh(S8 edr, S8 * const buffer_address, UNS8 buffer_length, UNS8 * const  buffer_index_address)
{//ACUX_LPF_EDR, ACUX_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, &ACUX_LPF_EDR_BUFFER_INDEX
	(*buffer_index_address)++;
	if(*buffer_index_address>=buffer_length)
	{
		*buffer_index_address=ZERO;
	}
	buffer_address[*buffer_index_address]=edr;//write current edr to buffer
}

/**************************************************************************/
/*  FUNCTION:  ACU_Buffer_Refresh                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
void ACU_Buffer_Refresh(S16 edr, S16 * const buffer_address, UNS8 buffer_length, UNS8 * const  buffer_index_address)
{//ACUX_LPF_EDR, ACUX_LPF_EDR_BUFFER, FRONT_EDR_BUFFER_LENGTH, &ACUX_LPF_EDR_BUFFER_INDEX
	(*buffer_index_address)++;
	if(*buffer_index_address>=buffer_length)
	{
		*buffer_index_address=ZERO;
	}
	buffer_address[*buffer_index_address]=edr;//write current edr to buffer
}
/**************************************************************************/
/*  FUNCTION:  TAF_Get_EDR_Offset                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
S8 Get_EDR_Offset(S8 * const buffer_address, UNS8 buffer_length, UNS8 buffer_index, UNS8 window_size)
{
	S8 edr_offset;
	if(buffer_index>=window_size)//get the edr offset
	{
		edr_offset=buffer_address[buffer_index-window_size];
	}
	else
	{
		edr_offset=buffer_address[buffer_length+buffer_index-window_size];
	}
	return(edr_offset);
}


static S32 Power_Sun(S8 * const buffer_address, UNS8 buffer_length)
{
	S32 temp_value;
	UNS32 index;

	temp_value = 0;
	index = 0;

	for(index = 0; index < buffer_length; index++)
	{
		temp_value = temp_value + buffer_address[index];
	}

	return (temp_value);
}

S32 Acu_Sun(S16 * const buffer_address, UNS8 buffer_length)
{
	S32 temp_value;
		UNS32 index;

		temp_value = 0;
		index = 0;

		for(index = 0; index < buffer_length; index++)
		{
			temp_value = temp_value + buffer_address[index];
		}

		return (temp_value);
}
/**************************************************************************/
/*  FUNCTION:  Divide_To_8bit                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/

S16 Divide_To_8bit(S32 input, S16 Multiplier, UNS16 Divide, UNS8 Offset, S16 Max, S16 Min)
{                       //ACUX_LPF,      ONE=1, ACU_LPF_DIVIDE=38, ZERO=0,     EDR_8_BIT_MAX=127, EDR_8_BIT_MIN=-128
	if(input>=ZERO)
	{
		input=(input*Multiplier+(S16)Divide/2)/(S16)Divide+Offset;
	}
	else
	{
		input=(input*Multiplier-(S16)Divide/2)/(S16)Divide+Offset;

	}
	if(input>Max)
	{
		input=Max;
	}
	else if(input<Min)
	{
		input=Min;
	}
	return(input);
}

/**************************************************************************/
/*  FUNCTION:  VSensor                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
static void VSensor(S32 input)
{
	S32 shift1;
	S32 shift2;
	S32 shift3;
	S32 shift4;
	S32 disp;
	S32 vel;
	if((input<=(S32)DEAD_ZONE)&&(input>=-(S32)DEAD_ZONE))
	{
		input=ZERO;
	}
	input=input<<VSENSOR_GAIN;
	if(SPRING_SWITCH_COUNTER<SPRING_SWITCH_COUNT)
	{
		shift1=DISP0>>DISP_1;
		shift2=DISP0>>DISP_2;
		shift3=(DISP0-DISP1)>>VEL_1;
		shift4=(DISP0-DISP1)>>VEL_2;
	}
	else
	{
		SPRING_SWITCH_COUNTER = 0;
		DISP0 = 0;
		DISP1 = 0;
		shift1=DISP0>>DISP_3;
		shift2=DISP0>>DISP_4;
		shift3=(DISP0-DISP1)>>VEL_3;
		shift4=(DISP0-DISP1)>>VEL_4;
	}
	disp=input-shift1-shift2-shift3-shift4-DISP1+2*DISP0;
	vel=disp-DISP0;
	DISP1=DISP0;
	DISP0=disp;
	DISP_FINAL=disp>>DISP_SHIFT;
	VEL_FINAL=vel>>VEL_SHIFT;

}
/**************************************************************************/
/*  FUNCTION:  AMA                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
void Data_AMA(S16 input0, S32 * const ama_address, S16 inputn, UNS8 windowsize, UNS8 gain, UNS16 counter)
{
	S32 subtract;
	subtract=input0-inputn;
	if(counter<=windowsize)
	{
		subtract=input0;
	}
	subtract=subtract<<gain;
	*ama_address=*ama_address+subtract;
}

/**************************************************************************/
/*  FUNCTION:  Table_Cross_Check                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
UNS8 Table_Cross_Check(S32 input_x, S32 input_y, UNS8 * const bin_count_address, UNS8 bin_count_length, UNS16 * const bin_size_address, UNS16 * const bin_limit_address, UNS16 * const array_y_address, UNS8 y_abs)
{
	UNS8 location=ZERO;
	UNS8 index;
	UNS8 flag=ZERO;
	if(y_abs==1U)
	{
		if(input_y<ZERO)
		{
			input_y=-input_y;
		}
	}
	if(input_x>=(S32)bin_limit_address[0])
	{
		input_x=input_x-bin_limit_address[0];
		for(index=1;index<=bin_count_length;index++)
		{
			if(input_x<bin_limit_address[index])
			{
				location=location+input_x/bin_size_address[index-1];
				break;
			}
			location=location+bin_count_address[index-1];
			input_x=input_x-bin_limit_address[index];
		}
		if((input_y>=(S32)array_y_address[location])&&(array_y_address[location]<THF_MAX_OUT))
		{
			flag=ONE;
		}
	}
	return(flag);

}

/**************************************************************************/
/*  FUNCTION:  Segment_Cross_Check                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
UNS8 Segment_Cross_Check(S32 input_x, S32 input_y, UNS16 * const array_x_address, UNS8 array_x_length, UNS16 * const array_y_address, UNS8 segment_or_table, UNS8 y_abs, UNS16 dead_zone)
{
	UNS8 location=ZERO;
	S32 subtract_x;
	UNS8 flag=ZERO;
	if(y_abs==1U)
	{
		if(input_y<ZERO)
		{
			input_y=-input_y;
		}
	}
	while(location<array_x_length)
	{
		subtract_x=input_x-array_x_address[location];
		if(subtract_x<ZERO)
		{
			break;
		}
		location++;
	}
	if(segment_or_table==SEGMENT_THRES)
	{
		UNS16 located_y=ZERO;
		if(location<array_x_length)
		{
			located_y=array_y_address[location];
		}
		if((input_x>=ZERO)&&(input_y>=(S32)located_y)&&(input_y>=(S32)dead_zone)&&(located_y<THF_MAX_OUT))
		{
			flag=ONE;
		}
	}
	else
	{
		if((input_x>=(S32)array_x_address[0])&&(input_y>=(S32)array_y_address[location-1])&&(array_y_address[location-1]<THF_MAX_OUT))
		{
			flag=ONE;
		}
	}
	return(flag);
}

/**************************************************************************/
/*  FUNCTION:  Deploy_Check                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
static void Deploy_Check(void)
{
	if((FRONT_DECISION_LEVEL[0]==0U)&&(FRONT_ALGO_ENTERED_COUNTER>=FRONT_DEPLOY_MIN_COUNT)&&((VEL_FINAL>2600)||(FRONT_ALGO_ENTERED_COUNTER<150)))//闁告瑯浜滃﹢顏嗙不濡や胶銆婇弶鈺傚姌椤㈡垹鎼鹃崨鎵畺5ms闁归潧绉甸ˉ鍛村蓟閿燂拷
	{
#ifndef	ACC_TO_FIRE_TEST_ENABLE
		if((MU_STG1_N_CROSSED==1U)&&(VSEN_N_CROSSED==1U))
#endif
		{
			FRONT_DECISION_LEVEL[0]=ONE;
		}
		if((PWR_SWITCH_CROSSED==1))
		{
			FRONT_DECISION_LEVEL[0]=ONE;
		}
	}

}

/**************************************************************************/
/*  FUNCTION:  High_Level_Deploy_Check                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
static void High_Level_Deploy_Check(void)
{
	if((FRONT_DECISION_LEVEL[0]==1U)&&(FRONT_DECISION_LEVEL[1]==0U)&&(DISP_FINAL>0))
	{
		if((MU_STG2_N_CROSSED==1U)&&(VSEN_N_CROSSED==1U))
		{
			FRONT_DECISION_LEVEL[1]=ONE;
		}
		if((MU_STG2_S_CROSSED==1U)&&(VSEN_S_CROSSED==1U)&&(FIS_SWITCH_CROSSED==1U))
		{
			FRONT_DECISION_LEVEL[1]=ONE;
		}
		if((STG2_DELAY_COUNTER>=STG2_MAX_DELAY)&&(STG2_MAX_DELAY>0U))
		{
			FRONT_DECISION_LEVEL[1]=ONE;
		}
	}
	if((FRONT_DECISION_LEVEL[1]==1U)&&(FRONT_DECISION_LEVEL[2]==0U))
	{
		if((MU_STG3_N_CROSSED==1U)&&(VSEN_N_CROSSED==1U))
		{
			FRONT_DECISION_LEVEL[2]=ONE;
		}
		if((MU_STG3_S_CROSSED==1U)&&(VSEN_S_CROSSED==1U)&&(FIS_SWITCH_CROSSED==1U))
		{
			FRONT_DECISION_LEVEL[2]=ONE;
		}
		if((STG3_DELAY_COUNTER>=STG3_MAX_DELAY)&&(STG3_MAX_DELAY>0U))//闁跨喐鏋婚幏鐑芥晸閺傘倖瀚归柨鐔告灮閹风兘鏁撻弬銈嗗闁跨喓绮告Η璇插皡閹风兘鏁撻弬銈嗗闁跨噦鎷?
		{
			FRONT_DECISION_LEVEL[2]=ONE;
		}
	}

}  /* High_Level_Deploy_Check */

/**************************************************************************/
/*  FUNCTION:  Rear_Deploy_Check                                    */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
#if __CLOSE_REAR_FUN__
static void Rear_Deploy_Check(void)
{
	if((REAR_DEPLOY==0U)&&(FRONT_ALGO_ENTERED_COUNTER>=FRONT_DEPLOY_MIN_COUNT))
	{
		if((MU_REAR_CROSSED==1U)&&(VSEN_REAR_CROSSED==1U))
		{
			REAR_DEPLOY=ONE;
		}
	}

}  /* Rear_Deploy_Check */
#endif

/**************************************************************************/
/*  FUNCTION:  ABS                                    */
/*                	                                                      */
/*  return value abs                                                      */
/**************************************************************************/
static S16	Abs(S16 data)
{
	if(data < 0)
		data = - data;

	return data;
}
