//
//
///********************code here*******************/
//
///** INCLUDE FILES **/
#include <string.h>
#include "caw_config.h"
////#include "side.h"
#include "front.h"
#include "caw.h"

#define __JALG_ENABLE__			1

#define PWR_GET_VBATT()					45
#define PWR_VBATT_LOW_FALLING_LIMIT   	12

//#define NUMBER_OF_SIDE_ALGORITHMS		(2U)
//#define DISABLE_ALG_FLAG				(0x01U)
//#define DIVISOR							(32U)
//#define DIVISOR_256						(256U)

#define ACU_MODE_NORMAL					((UNS8)0xA5)
#define ACU_MODE_PLANT					((UNS8)0x5A)
#define ACU_MODE						((UNS8)0xA5)//CO

///* connector directon 	Alg */
///* LEFT					0   */
///* RIGHT				1   */
///* FRONT				3   */
///* REAR					2   */
#define SDM_INVERT_POLARITY_LEFT		(0U)
#define SDM_INVERT_POLARITY_RIGHT		(1U)
#define SDM_INVERT_POLARITY_FRONT		(3U)
#define SDM_INVERT_POLARITY_REAR		(2U)

#define IS_CRASH_ACTIVE_MASK			((UNS8)0x01 << 0)
#define IS_CRASH_ACTIVE_CASE_NO			((UNS8)0x00 << 0)
#define IS_CRASH_ACTIVE_CASE_YES		((UNS8)0x01 << 0)

#define IS_LEFT_ACTIVE_MASK				((UNS8)0x01 << 1)
#define IS_LEFT_ACTIVE_CASE_NO			((UNS8)0x00 << 1)
#define IS_LEFT_ACTIVE_CASE_YES			((UNS8)0x01 << 1)
//
#define IS_RIGHT_ACTIVE_MASK			((UNS8)0x01 << 2)
#define IS_RIGHT_ACTIVE_CASE_NO			((UNS8)0x00 << 2)
#define IS_RIGHT_ACTIVE_CASE_YES		((UNS8)0x01 << 2)
//
#define IS_FRONT_ACTIVE_MASK			((UNS8)0x01 << 3)
#define IS_FRONT_ACTIVE_CASE_NO			((UNS8)0x00 << 3)
#define IS_FRONT_ACTIVE_CASE_YES		((UNS8)0x01 << 3)

#define WAS_CRASH_ACTIVE_MASK			((UNS8)0x01 << 4)
#define WAS_CRASH_ACTIVE_CASE_NO		((UNS8)0x00 << 4)
#define WAS_CRASH_ACTIVE_CASE_YES		((UNS8)0x01 << 4)

#define WAS_LEFT_ACTIVE_MASK			((UNS8)0x01 << 5)
#define WAS_LEFT_ACTIVE_CASE_NO			((UNS8)0x00 << 5)
#define WAS_LEFT_ACTIVE_CASE_YES		((UNS8)0x01 << 5)

#define WAS_RIGHT_ACTIVE_MASK			((UNS8)0x01 << 6)
#define WAS_RIGHT_ACTIVE_CASE_NO		((UNS8)0x00 << 6)
#define WAS_RIGHT_ACTIVE_CASE_YES		((UNS8)0x01 << 6)

#define WAS_FRONT_ACTIVE_MASK			((UNS8)0x01 << 7)
#define WAS_FRONT_ACTIVE_CASE_NO		((UNS8)0x00 << 7)
#define WAS_FRONT_ACTIVE_CASE_YES		((UNS8)0x01 << 7)

#define IS_FRONT_ENABLED_MASK			((UNS8)0x01 << 0)
#define IS_FRONT_ENABLED_CASE_NO		((UNS8)0x00 << 0)
#define IS_FRONT_ENABLED_CASE_YES		((UNS8)0x01 << 0)

#define IS_LEFT_ENABLED_MASK			((UNS8)0x01 << 1)
#define IS_LEFT_ENABLED_CASE_NO			((UNS8)0x00 << 1)
#define IS_LEFT_ENABLED_CASE_YES		((UNS8)0x01 << 1)

#define IS_RIGHT_ENABLED_MASK			((UNS8)0x01 << 2)
#define IS_RIGHT_ENABLED_CASE_NO		((UNS8)0x00 << 2)
#define IS_RIGHT_ENABLED_CASE_YES		((UNS8)0x01 << 2)

#define IS_FRONT_EXIT_MASK				((UNS8)(WAS_FRONT_ACTIVE_MASK \
											| IS_FRONT_ACTIVE_MASK))
#define IS_FRONT_EXIT_CASE_YES			((UNS8)(WAS_FRONT_ACTIVE_CASE_YES \
											| IS_FRONT_ACTIVE_CASE_NO))

#define IS_LEFT_EXIT_MASK				((UNS8)(WAS_LEFT_ACTIVE_MASK \
											| IS_LEFT_ACTIVE_MASK))
#define IS_LEFT_EXIT_CASE_YES			((UNS8)(WAS_LEFT_ACTIVE_CASE_YES \
											| IS_LEFT_ACTIVE_CASE_NO))

#define IS_RIGHT_EXIT_MASK				((UNS8)(WAS_RIGHT_ACTIVE_MASK \
											| IS_RIGHT_ACTIVE_MASK))
#define IS_RIGHT_EXIT_CASE_YES			((UNS8)(WAS_RIGHT_ACTIVE_CASE_YES \

#define SET_WAS_CRASH_ACTIVE			(WAS_CRASH_ACTIVE_CASE_YES)
#define CLR_WAS_CRASH_ACTIVE			(~WAS_CRASH_ACTIVE_CASE_YES)

#define SET_IS_CRASH_ACTIVE				(IS_CRASH_ACTIVE_CASE_YES)
#define CLR_IS_CRASH_ACTIVE				(~IS_CRASH_ACTIVE_CASE_YES)

#define SET_WAS_RIGHT_ACTIVE			(WAS_RIGHT_ACTIVE_CASE_YES)
#define CLR_WAS_RIGHT_ACTIVE			(~WAS_RIGHT_ACTIVE_CASE_YES)

#define SET_WAS_LEFT_ACTIVE				(WAS_LEFT_ACTIVE_CASE_YES)
#define CLR_WAS_LEFT_ACTIVE				(~WAS_LEFT_ACTIVE_CASE_YES)

#define SET_WAS_FRONT_ACTIVE			(WAS_FRONT_ACTIVE_CASE_YES)
#define CLR_WAS_FRONT_ACTIVE			(~WAS_FRONT_ACTIVE_CASE_YES)

#define SET_IS_RIGHT_ACTIVE				(IS_RIGHT_ACTIVE_CASE_YES)
#define CLR_IS_RIGHT_ACTIVE				(~IS_RIGHT_ACTIVE_CASE_YES)

#define SET_IS_LEFT_ACTIVE				(IS_LEFT_ACTIVE_CASE_YES)
#define CLR_IS_LEFT_ACTIVE				(~IS_LEFT_ACTIVE_CASE_YES)

#define SET_IS_FRONT_ACTIVE				(IS_FRONT_ACTIVE_CASE_YES)
#define CLR_IS_FRONT_ACTIVE				(~IS_FRONT_ACTIVE_CASE_YES)

#define SET_IS_RIGHT_ENABLED			(IS_RIGHT_ENABLED_CASE_YES)
#define CLR_IS_RIGHT_ENABLED			(~IS_RIGHT_ENABLED_CASE_YES)

#define SET_IS_LEFT_ENABLED				(IS_LEFT_ENABLED_CASE_YES)
#define CLR_IS_LEFT_ENABLED				(~IS_LEFT_ENABLED_CASE_YES)

#define SET_IS_FRONT_ENABLED			(IS_FRONT_ENABLED_CASE_YES)
#define CLR_IS_FRONT_ENABLED			(~IS_FRONT_ENABLED_CASE_YES)

#define IS_ANYONE_ACTIVE_MASK			(IS_FRONT_ACTIVE_MASK \
										 | IS_LEFT_ACTIVE_MASK \
										 | IS_RIGHT_ACTIVE_MASK)
#define IS_ANYONE_ACTIVE_CASE_NO		((UNS8)0)

#define IS_ANY_SIDE_ENABLED_MASK		(IS_LEFT_ENABLED_MASK \
										 | IS_RIGHT_ENABLED_MASK)
#define IS_ANY_SIDE_ENABLED_CASE_NO		((UNS8)0)

#if (__FUEL_CUTOFF__ == 1)
#define IS_ROLL_ENABLED_MASK			((UNS8)0x01 << 0)
#define IS_ROLL_ENABLED_CASE_NO			((UNS8)0x00 << 0)
#define IS_ROLL_ENABLED_CASE_YES		((UNS8)0x01 << 0)

#define IS_ROLL_ACTIVE_MASK				((UNS8)0x01 << 1)
#define IS_ROLL_ACTIVE_CASE_NO			((UNS8)0x00 << 1)
#define IS_ROLL_ACTIVE_CASE_YES			((UNS8)0x01 << 1)

#define SET_IS_ROLL_ENABLED				(IS_ROLL_ENABLED_CASE_YES)
#define CLR_IS_ROLL_ENABLED				(~IS_ROLL_ENABLED_CASE_YES)

#define SET_IS_ROLL_ACTIVE				(IS_ROLL_ACTIVE_CASE_YES)
#define CLR_IS_ROLL_ACTIVE				(~IS_ROLL_ACTIVE_CASE_YES)


#endif
//
//#if (__AUXILIARY_ENS_ENABLE__ == 1)
//typedef enum
//{
//	ENS_DIR_LEFT = 0,
//	ENS_DIR_RIGHT,
//
//	ENS_DIR_NUM
//} AUX_ENS_DIR_E;
//
//typedef enum
//{
//	ENS_LEVEL_INACTIVE = 0,
//	ENS_LEVEL_LIGHT,
//	ENS_LEVEL_SEVERE,
//
//	ENS_LEVEL_NUM
//} AUX_ENS_LEVELS_E;
//#endif
//

typedef struct
{
	BOOL 	IsAlgoRunSfetOnDelayDone;
	BOOL 	AlgAlternate;
	UNS8	Reserved[2];
} CAW_CONTROL_PKG_T;
//
//#if (__AUXILIARY_ENS_ENABLE__ == 1)
//typedef struct
//{
//	S16 Velocity;
//	UNS16 SevereTimer;
//	UNS8 LowVelocityCnt;
//	UNS8 VelocityCalcFlag;
//	AUX_ENS_LEVELS_E Level[ENS_DIR_NUM];
//} AUX_ENS_CTRL_T;
//#endif
//
///** PUBLIC DATA **/
//#if (__JALG_ENABLE__ == 0)
//TAF_GLOBAL_VAR_T TAF;
//TAS_GLOBAL_VAR_T TAS;//TAS[NUMBER_OF_SIDE_ALGORITHMS]; dong del
//#endif
CAW_T CAW;

//UNS32 AccTestDataFireSize;
//UNS32 ACCTestDataIndex;
///** PRIVATE DATA **/
static CAW_CONTROL_PKG_T CawCtrlPkg;
//volatile uint32_t algorithmFireFlag = 0;
//#if (__AUXILIARY_ENS_ENABLE__ == 1)
//static AUX_ENS_CTRL_T AuxENS;
//#endif
//
//
/** LOCAL FUNCTION PROTOTYPES **/
static void CheckStartUp(void);
//
//
//#if (__AUXILIARY_ENS_ENABLE__ == 1)
//static void AuxENSRamInit(void);
//static void AuxENSProcess(void);
//static UNS8 AuxENSMonitor(void);
//static void AuxENSLevelUpdate(S16 inputData);
//#endif


/** GLOBAL FUNCTIONS **/
/*****************************************************************************
 *	CAW_RamInit:
 *
 *	PARAMETERS: None.
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: This function will initialize all global and static
 *	variables owned by this module.
 *
 *	RETURNS: None
 *
 *****************************************************************************
 */
void CAW_RamInit(void)
{
	(void)memset(&CawCtrlPkg, ZERO, (sizeof(CAW_CONTROL_PKG_T)));

	/* Calibration parameters should be valid:
	And Side Algorithm should be enabled */

#if (__AUXILIARY_ENS_ENABLE__ == 1)
	AuxENSRamInit();
#endif
#if (__JALG_ENABLE__ == 1)
	TAF_InitializeRam(); // To algorithm front
//	TAS_InitializeRam(); // To algorithm side
#endif

} /* End CAW_RamInit */

/*****************************************************************************
 *	CAW_ActiveAlgorithm:�����㷨
 *
 *	PARAMETERS: None
 *
 *	DESCRIPTION: This function will determine whether any algorithm is active.
 *
 *	RETURNS: TRUE if algorithms are running
 *			 FALSE if algorithms are not running
 *
 *****************************************************************************
 */

/* Test_Trace:Test_CAW_ActiveAlgorithm */

BOOL CAW_ActiveAlgorithm(void)
{
	return (IS_CRASH_ACTIVE_CASE_YES == (CAW.CrashAlgActive.Part & IS_CRASH_ACTIVE_MASK));
}  /* End CAW_ActiveAlgorithm */


#if (__FUEL_CUTOFF__ == 1)
/*****************************************************************************
 *	CAW_FuelCutoffAlgoActive:
 *
 *	PARAMETERS: None
 *
 *	DESCRIPTION: This function will determine whether a fuel cutoff algorithm is active.
 *
 *	RETURNS: TRUE if algorithms are running
 *			 FALSE if algorithms are not running
 *
 *****************************************************************************
 */
BOOL CAW_FuelCutoffAlgoActive(void)
{
	return (IS_ROLL_ACTIVE_CASE_YES == (CAW.RollAlg.Part & IS_ROLL_ACTIVE_MASK));
}  /* End CAW_FuelCutoffAlgoActive */
#endif


/*****************************************************************************
 *	CAW_frontal:
 *
 *	PARAMETERS: None
 *
 *	DESCRIPTION: This function will call the front crash algorithm.
 *				 It needs to be called at the crash algorithm rate.
 *
 *	RETURNS:  TRUE if the algorithm is running
 *
 *****************************************************************************
 */

/* Test_Trace:Test_CAW_frontal 正面的*/
void CAW_frontal(void)
{
	/* Get appropriate data for algorithm */

	(void) ACCEL_GetAccelData(&CAW.AccData.X, &CAW.AccData.Y,&CAW.AccData.Z);

	CAW.IsAlgoCalledYet.Bit.Front = TRUE;
	/*Front ALG is active*/
	if (TRUE == FRONT_ALGO_ON)
	{
		CAW.CrashAlgActive.Part |= (SET_IS_FRONT_ACTIVE | SET_WAS_FRONT_ACTIVE);
		if (FRONT_DECISION_LEVEL[0] == TRUE)
		{
			CAW.CacheAlgDecisionLevel.Bit.Level_1 = TRUE;
		}
		if (FRONT_DECISION_LEVEL[1] == TRUE)
		{
			CAW.CacheAlgDecisionLevel.Bit.Level_2 = TRUE;
		}
		if (FRONT_DECISION_LEVEL[2] == TRUE)
		{
			CAW.CacheAlgDecisionLevel.Bit.Level_3 = TRUE;
		}
		if (REAR_DEPLOY == 1 )
		{
			CAW.CacheAlgDecisionLevel.Bit.Rear = TRUE;
		}
	}
	else
	{
		CAW.CrashAlgActive.Part &= CLR_IS_FRONT_ACTIVE;
		if (IS_FRONT_ENABLED_CASE_YES != (CAW.CrashAlgEnable.Part & IS_FRONT_ENABLED_MASK))
		{
			CAW.IsAlgoCalledYet.Bit.Front = FALSE;
		}
	}
	//DebugMessageFromCan(0x301, CAW.IsAlgoCalledYet.Bit.Front);
	if (TRUE == CAW.IsAlgoCalledYet.Bit.Front)
	{
		/* Yes, continue to call it */
		TAF_Algo(CAW.AccData.X, CAW.AccData.Y,CAW.AccData.Z, CAW.RSUData.LFIS, CAW.RSUData.RFIS);
		/*--------------------------------------------------------------------------------------*/
		/*--Reason:																				*/
		/*		1)Theoretically,EDR recorded should be consistent with the data used by the		*/
		/*		  algorithm.But actually, EDR frontal buffer and Algorithm synchronization 		*/
		/*		  flag was not consistent in this function,this is not to be expected.			*/
		/*		2)Why not update EDR buffer directly with the flag TAF.AlgorithmSection?		*/
		/*		  After the algorithm is Disable, TAF.AlgorithmSection is no longer updated 	*/
		/*		  and keeps the last value constant which is impacting on EDR record data		*/
		/*--Method:																				*/
		/*			Synchronous EDR data collection flag from Algorithm,Fixed Issue :RAC-606	*/
		/*--------------------------------------------------------------------------------------*/
		CawCtrlPkg.AlgAlternate = FRONT_ALGO_1MS_COUNTER;
		/* end */
	}

	/*1ms record accel and satelite*/
	if (TRUE == CawCtrlPkg.AlgAlternate)
	{
		CawCtrlPkg.AlgAlternate = FALSE;
		/* RAC-180 record the vehicle lateral acceleration */
	}
	else
	{
		CawCtrlPkg.AlgAlternate = TRUE;
	}

	#if (__AUXILIARY_ENS_ENABLE__ == 1)
	AuxENSProcess();
	#endif

	/* Determine Startup */
	CheckStartUp();

}  /* End CAW_frontal */


/*****************************************************************************
 *	CAW_sides:
 *
 *	PARAMETERS:  None
 *
 *	DESCRIPTION: This function will call the side crash algorithms.
 *				 It needs to be called at the crash algorithm rate.
 *
 *
 *	RETURNS: TRUE if the algorithm is running
 *
 *****************************************************************************
 */

///* Test_Trace:Test_CAW_sides */
//void CAW_sides(void)
//{
//	/* Sidel and sider acceleration data already get in the CAW_frontal() function */
//	/* Get appropriate data for algorithm */
//	/* 2009/02/17 Hunk, modify according arches improvement v1.47 */
//	/* notify on/off algorithm based on algorithm flag */
//	/*Left ALG is active*/
//	CAW.IsAlgoCalledYet.Bit.Left = TRUE;
//	if (TRUE == LEFT_ALGO_ON)
//	{
//		CAW.CrashAlgActive.Part |= (SET_IS_LEFT_ACTIVE | SET_WAS_LEFT_ACTIVE);
//		if (LEFT_DECISION_LEVEL0 == TRUE)
//		{
//			CAW.CacheAlgDecisionLevel.Bit.Left = TRUE;
//		}
//	}
//	else
//	{
//		CAW.CrashAlgActive.Part &= CLR_IS_LEFT_ACTIVE;
//		if (IS_LEFT_ENABLED_CASE_YES != (CAW.CrashAlgEnable.Part & IS_LEFT_ENABLED_MASK))
//		{
//			CAW.IsAlgoCalledYet.Bit.Left = FALSE;
//			CAW.RSUData.LSIS = ZERO;
//			CAW.RSUData.LCSIS = ZERO;
//		}
//	}
//	/*Right ALG is active*/
//	CAW.IsAlgoCalledYet.Bit.Right = TRUE;
//	if (TRUE == RIGHT_ALGO_ON)
//	{
//		CAW.CrashAlgActive.Part |= (SET_IS_RIGHT_ACTIVE | SET_WAS_RIGHT_ACTIVE);
//		if (RIGHT_DECISION_LEVEL0 == TRUE)
//		{
//			CAW.CacheAlgDecisionLevel.Bit.Right = TRUE;
//		}
//	}
//	else
//	{
//		CAW.CrashAlgActive.Part &= CLR_IS_RIGHT_ACTIVE;
//		if (IS_RIGHT_ENABLED_CASE_YES != (CAW.CrashAlgEnable.Part & IS_RIGHT_ENABLED_MASK))
//		{
//			CAW.IsAlgoCalledYet.Bit.Right = FALSE;
//			CAW.RSUData.RSIS = ZERO;
//			CAW.RSUData.RCSIS = ZERO;
//		}
//	}
//#if (__JALG_ENABLE__ == 0)
//	/* algorithm enabled or has it been running? */
//	if (FALSE != CAW.IsAlgoCalledYet.Bit.Left)
//	{/* Yes, continue to call it */
//		/*(2018/01/04-Modify by Spencer): When front algorithm active & front algorithm decision enable, the side algorithm should active with lower value.-bob.Xu*/
//		if ((IS_FRONT_ACTIVE_CASE_YES == (CAW.CrashAlgActive.Part & IS_FRONT_ACTIVE_MASK)) && (TRUE == FRONT_DECISION_LEVEL[TAF_LEVEL_0]))
//		{
//			TAS_Algo(CAW.RSUData.LSIS / 2, CAW.RSUData.RSIS / 2,TAS_LEFT_SIDE_ALGORITHM);
//		}
//		else
//		{
//			TAS_Algo(CAW.RSUData.LSIS, CAW.RSUData.RSIS,TAS_LEFT_SIDE_ALGORITHM);
//		}
//	}
//	/* algorithm enabled or has it been running? */
//	if (FALSE != CAW.IsAlgoCalledYet.Bit.Right)
//	{/* Yes, continue to call it */
//		if ((IS_FRONT_ACTIVE_CASE_YES == (CAW.CrashAlgActive.Part & IS_FRONT_ACTIVE_MASK)) && (TRUE == FRONT_DECISION_LEVEL[TAF_LEVEL_0]))
//		{
//			TAS_Algo(CAW.RSUData.LCSIS / 2, CAW.RSUData.RCSIS / 2,TAS_RIGHT_SIDE_ALGORITHM);
//		}
//		else
//		{
//			TAS_Algo(CAW.RSUData.LCSIS, CAW.RSUData.RCSIS,TAS_RIGHT_SIDE_ALGORITHM);
//		}
//	}
//
//#else
//	/* algorithm enabled or has it been running? */
//	if (FALSE != (CAW.IsAlgoCalledYet.Bit.Right | CAW.IsAlgoCalledYet.Bit.Left))
//	{/* Yes, continue to call it */
//		TAS_Algo(
//						CAW.RSUData.LSIS, CAW.RSUData.RSIS,
//						CAW.RSUData.LCSIS, CAW.RSUData.RCSIS,
//						CAW.RSUData.LRPS, CAW.RSUData.RRPS
//						);
//	}
//#endif
//
//	/*(total size:10bits):record 1bytes(bit8~bit1)*/
//	REC_BufferSideData((REC_DATA_T)(LBSIS_LPF_EDR),
//					  (REC_DATA_T)(RBSIS_LPF_EDR),
//					  (REC_DATA_T)(LCSIS_LPF_EDR),
//					  (REC_DATA_T)(RCSIS_LPF_EDR),
//					  (REC_DATA_T)(LP_LPF_EDR),
//					  (REC_DATA_T)(RP_LPF_EDR)
//					  );
//
//
//	/* Determine Startup */
//	CheckStartUp();
//
//}  /* End CAW_sides */

//void DPL_ClearB0AlgoEnable(void)
//{
//	DplEnablers.DplConf.B0_AlgoEnable.B0_AlgoEnablerByte = ZERO;
//} /* End DPL_ClearB0AlgoEnable */
/*****************************************************************************
 *	CAW_RunStop:
 *
 *	PARAMETERS: None
 *
 *	DESCRIPTION: This function will determine the overall algorithm state
 *				 and call the deploy function.
 *				 when algorithms stop it will inform the appropriate systems.
 *
 *	RETURNS: None
 *
 *****************************************************************************
 */

/* Test_Trace:Test_CAW_RunStop */

void CAW_RunStop(void)
{

	/* Any individual algorithm running? */
	if (IS_ANYONE_ACTIVE_CASE_NO != (CAW.CrashAlgActive.Part & IS_ANYONE_ACTIVE_MASK))
	{
		//DebugMessageFromCan(0x301, CawCtrlPkg.IsAlgoRunSfetOnDelayDone);
		/* Yes. */
		/* Crash algorithm time base */
		CAW.CrashAlgTimer++;
#ifdef _SFET_SAFING_MODE_
		SFET_TurnOn();
#endif
		if (TRUE == CawCtrlPkg.IsAlgoRunSfetOnDelayDone)
		{
			/* algorithms running, check for squib deployment */
			DPL_Periodic();
		}
		/*for 500us delay to enter deploy */
		else
		{
			CawCtrlPkg.IsAlgoRunSfetOnDelayDone = TRUE;
		}

		/* Get the time when battery becomes disconnected */
		if ((PWR_GET_VBATT() < PWR_VBATT_LOW_FALLING_LIMIT)
				&& (CAW.BattDisconnectTime == ZERO)
			)
		{
			CAW.BattDisconnectTime = CAW.CrashAlgTimer;
		}

		if ((FRONT_ALGO_MAX_COUNT <= FRONT_ALGO_ENTERED_COUNTER)
			&& (FALSE == FRONT_ALGO_ON))
		{
//			ACCEL_RedoCalibration();     //xia_update230407
//			SAT_RedoCalibration(SAT_FRONT);
			FRONT_ALGO_ENTERED_COUNTER = ZERO; /* reset to 0 to prevent re-running recalibration */
			PWR_ALGO_ENTERED_COUNTER = ZERO;
			CAW.CrashAlgActive.Part &= CLR_IS_FRONT_ACTIVE;
		}

//		if ((SIDE_ALGO_MAX_COUNT <= LEFT_ALGO_ENTERED_COUNTER)
//			&& (FALSE == LEFT_ALGO_ON)
//			)
//		{
//			SAT_RedoCalibration(SAT_LEFT);
//			LEFT_ALGO_ENTERED_COUNTER = ZERO;  /* reset to 0 to prevent re-running recalibration */
//			CAW.CrashAlgActive.Part &= CLR_IS_LEFT_ACTIVE;
//		}
//
//		if ((SIDE_ALGO_MAX_COUNT <= RIGHT_ALGO_ENTERED_COUNTER)
//			&& (FALSE == RIGHT_ALGO_ON))
//		{
//			SAT_RedoCalibration(SAT_RIGHT);
//			RIGHT_ALGO_ENTERED_COUNTER = ZERO; /* reset to 0 to prevent re-running recalibration */
//			CAW.CrashAlgActive.Part &= CLR_IS_RIGHT_ACTIVE;
//		}

	}
	else
	{
		/* Was any algorithm running? */
		if (IS_CRASH_ACTIVE_CASE_YES == (CAW.CrashAlgActive.Part & IS_CRASH_ACTIVE_MASK))
		{
			/* Yes, time to exit */
			/* Place exit code here */
			/* force clean up in the deploy module */
			//DPL_CrashAlgorithmExit();////////////////////////////????
			/* Turn off FLIC */
#ifdef _SFET_SAFING_MODE_
			FLIC_CrashAlgorithmExit();
#endif
		//	REC_CollectEventInfo(PHASE_ALG_EXIT,TRIGGER_TYPE_HORIZON);//????????
#ifdef _SFET_SAFING_MODE_
			SFET_TurnOff();
#endif
			CawCtrlPkg.IsAlgoRunSfetOnDelayDone = FALSE;
			/* for 250ms delay,in SFET real time test*/
			//SFET.AlgorithmStopFlag = TRUE;

			/* Algorithm exiting */
			CAW.CrashAlgActive.Part &= (CLR_IS_CRASH_ACTIVE \
										& CLR_IS_FRONT_ACTIVE \
										& CLR_IS_LEFT_ACTIVE \
										& CLR_IS_RIGHT_ACTIVE);

			/*Clear algorithm decision level*/
			FRONT_DECISION_LEVEL[TAF_LEVEL_0] = ZERO;
			FRONT_DECISION_LEVEL[TAF_LEVEL_1] = ZERO;
			FRONT_DECISION_LEVEL[TAF_LEVEL_2] = ZERO;


#if (__JALG_ENABLE__ == 0)
//			FRONT_DECISION_LEVEL[TAF_LEVEL_3] = ZERO;
//			FRONT_DECISION_LEVEL[TAF_LEVEL_4] = ZERO;
#endif
//			LEFT_DECISION_LEVEL0 = ZERO;
//			RIGHT_DECISION_LEVEL0 = ZERO;
#if (__JALG_ENABLE__ == 1)
//			LEFT_DECISION_LEVEL1 = ZERO;
//			RIGHT_DECISION_LEVEL1 = ZERO;
#endif
			REAR_DEPLOY = ZERO;

			/*Clear the DPL decision level*/
//			DPL_ClearB0AlgoEnable();
		}
	}
}  /* End CAW_RunStop */


/*****************************************************************************
*  CAW_SetEnableDisableState:
*
*  PARAMETERS: None
*
*  DESCRIPTION: This routine will enable or disable frontal and
*  				side algorithms. It is called every exec loop.
*
*  RETURNS: None
*
 *****************************************************************************
 */

/* Test_Trace:Test_CAW_SetEnableDisableState */
void CAW_SetEnableDisableState(void)
{
	if (((ACU_MODE_PLANT != ACU_MODE))
//		&& (PWR_IS_ALG_ENABLE())	//dong del
        /* When ACCEL or SPI failed during ALG activating, keep ALG enable until
           stop running even if faults matured. In the meanwhile, zero was passed
           to ALG for sensor with invalid data, all other sensors continue to
           process real data */
	    	&& (((ACCEL_IsStatusGood() == TRUE)
			/*	&& (SPI_ALG_ENA == TRUE)*/) //dong del
		|| (IS_CRASH_ACTIVE_CASE_YES == (CAW.CrashAlgActive.Part & IS_CRASH_ACTIVE_MASK)))

//		&& (TRUE == FLIC_StatusGood())
//		&& (A2D_OK)
#ifdef _SFET_SAFING_MODE_
		&& (SFET_AlgorithmStopStatus() == FALSE)  IN SAFING
#endif
		)
	{
		if ((CALIB_FROM.Data.CrashEnable.CrashEnableAlg.EnableFrontCrash == TRUE)
	//		&& ((SAT_StatusGood(SAT_FRONT) == TRUE)///!!!!!!!!!!!!!!!!!!!!!!!
					||(/*((UNS8)NONE_SPLUDGEMODE < CanAplSpludgeMode) dong del && */(ACU_MODE_PLANT == ACU_MODE))
#ifdef _SFET_SAFING_MODE_
			&& (SFET_SafingFrontAlgoStop() == FALSE)
#endif
			)
		{
			if (IS_FRONT_ENABLED_CASE_NO == (CAW.CrashAlgEnable.Part & IS_FRONT_ENABLED_MASK))
			{
#if (__JALG_ENABLE__ == 1)
				TAF_InitializeRam();
#endif
				CAW.CrashAlgEnable.Part |= SET_IS_FRONT_ENABLED;
			}
		}
		else
		{
			CAW.CrashAlgEnable.Part &= CLR_IS_FRONT_ENABLED;
		}

		if (CALIB_FROM.Data.CrashEnable.CrashEnableAlg.EnableSideCrash == TRUE)
		{
#if 0
			if ((SAT_StatusGood(SAT_LEFT) == FALSE)&& (SAT_StatusGood(SAT_RIGHT) == FALSE))
			{
				CAW.CrashAlgEnable.Part &= (CLR_IS_LEFT_ENABLED & CLR_IS_RIGHT_ENABLED);
			}
			else
			{
				if ((IS_LEFT_ENABLED_CASE_YES | IS_RIGHT_ENABLED_CASE_YES) != (CAW.CrashAlgEnable.Part & (IS_LEFT_ENABLED_MASK | IS_RIGHT_ENABLED_MASK)))
				{
#if (__JALG_ENABLE__ == 1)
					TAS_InitializeRam();
#endif
					CAW.CrashAlgEnable.Part |= (SET_IS_LEFT_ENABLED | SET_IS_RIGHT_ENABLED);
				}
			}
#endif
		}
		else
		{
			CAW.CrashAlgEnable.Part &= (CLR_IS_LEFT_ENABLED & CLR_IS_RIGHT_ENABLED);
		}
	}
	else
	{
		CAW.CrashAlgEnable.Part &= (CLR_IS_FRONT_ENABLED & CLR_IS_LEFT_ENABLED & CLR_IS_RIGHT_ENABLED);
	}
#if (__FUEL_CUTOFF__ == 1)
	/* Disable and Enable Fuel Cutoff algorithm state */
	if ((ACU_MODE_PLANT != ACU_MODE)
		&& (PWR_IS_FUEL_ALG_ENABLE())
        /* When ACCEL or SPI failed during ALG activating, keep ALG enable until
           stop running even if faults matured. In the meanwhile, zero was passed
           to ALG for sensor with invalid data, all other sensors continue to
           process real data */
		#if CAN_GET_ACCEL_DEBUG
			&& ((1 //(ACCEL_IsStatusGood() == TRUE)
		#else
		&& (((TRUE == ACCEL_IsStatusGood())
		#endif
				&& (TRUE == ZAXIS_GetAccelStatus())
				&& (SPI_FUEL_CUT_OFF_ALG_ENA == TRUE)
				)
			|| (IS_ROLL_ACTIVE_CASE_YES == (CAW.RollAlg.Part & IS_ROLL_ACTIVE_MASK)))
		//&& (WDOG_IsExternalWdogReady() == TRUE)
		&& (TRUE == FLIC_StatusGood())
		&& (A2D_OK)	)
	{
		CAW.RollAlg.Part |= SET_IS_ROLL_ENABLED;
	}
	else
	{
		CAW.RollAlg.Part &= CLR_IS_ROLL_ENABLED;
	}

	/* Set Fuel Cutoff alogrithm running state active */
	if (TAR.RollingCounter != ZERO)
	{
		CAW.RollAlg.Part |= SET_IS_ROLL_ACTIVE;
		/*EDR Collect event Information*/
	}
	else
	{
		CAW.RollAlg.Part &= CLR_IS_ROLL_ACTIVE;
	}
#endif
	/* Put interrupt state back */

}  /* End CAW_SetEnableDisableState */


/*****************************************************************************
*  CAW_GetVehicleYData:
*
*  PARAMETERS: None
*
*  DESCRIPTION:	This function will calculate vehicle lateral accel value,
* 				depends on the assembly direction
*
*  RETURNS: None
*
*****************************************************************************/
S16 CAW_GetVehicleYData(void)
{
	S16  vehicle_y = ZERO;
	/* Calculate XY data based on ACU assembly direction */

	if (SDM_INVERT == SDM_INVERT_POLARITY_LEFT)
	{
		vehicle_y = CAW.AccData.X + CAW.AccData.Y;
	}
	else if (SDM_INVERT == SDM_INVERT_POLARITY_RIGHT)
	{
		vehicle_y = (-CAW.AccData.X) - CAW.AccData.Y;
	}
	else if (SDM_INVERT == SDM_INVERT_POLARITY_FRONT)
	{
		vehicle_y = CAW.AccData.X - CAW.AccData.Y;
	}
	else if (SDM_INVERT == SDM_INVERT_POLARITY_REAR)
	{
		vehicle_y = (-CAW.AccData.X) + CAW.AccData.Y;
	}
	else
	{
		/* Do nothing */
	}
	return (vehicle_y);
}/* End of CAW_GetVehicleYData() */

//
/*****************************************************************************
*  CAW_GetSatelliteData:
*
*  PARAMETERS: None
*
*  DESCRIPTION:	This function will get frontal, sidel and sider acceleration data
*  				back recalled function
*
*  RETURNS: None
*
*****************************************************************************/
void CAW_GetSatelliteData(void)
{
	/* The parameter is fcsl address for getting frontal, sidel and sider acceleration data */
	//(void) SAT_GetAccData(&CAW.RSUData.LFIS);
}/* End of CAW_GetSatelliteData() */

/*****************************************************************************
 *	CAW_CheckStartUp:
 *
 *	PARAMETERS: None
 *
 *	DESCRIPTION: This function will determine algorithm Startup.
 *
 *	RETURNS: None
 *
 *****************************************************************************
 */

/* Test_Trace:Test_CheckStartUp */
static void CheckStartUp(void)
{
	//DebugMessageFromCan(0x301, CAW.CrashAlgActive.Part);
	if (IS_CRASH_ACTIVE_CASE_NO == (CAW.CrashAlgActive.Part & IS_CRASH_ACTIVE_MASK))
	{
		if (IS_ANYONE_ACTIVE_CASE_NO != (CAW.CrashAlgActive.Part & IS_ANYONE_ACTIVE_MASK))
		{
			/* Algorithm started up */
			CAW.CrashAlgActive.Part |= (SET_IS_CRASH_ACTIVE | SET_WAS_CRASH_ACTIVE);

			/* Place startup code here */
			DPL_AlgorithmStartup();
//			REC_AlgInit();


			/* Gather startup data */
			CAW.BattLevelAlgEntry = PWR_GET_VBATT();
			//CAW.VoltageEnergyReserve = SFET_GetVermonAD();
			/* Initialize Time Base */
			CAW.CrashAlgTimer = ZERO;
			CAW.BattDisconnectTime = ZERO;

			/*suspend flic test */
			// FLIC_CrashAlgorithmStart();dong del
			/*turn on sfet*/
#ifdef _SFET_SAFING_MODE_
			SFET_TurnOn();
#endif
		}
	}
}  /* End CheckStartUp */



#if (__AUXILIARY_ENS_ENABLE__ == 1)
/*(2018/01/04-Modify by Spencer): RAC-609 add Aux ENS function.*/
/*****************************************************************************
*  AuxENSRamInit:
*
*  PARAMETERS: None
*
*  DESCRIPTION:
*
*  RETURNS:
*
 ******************************************************************************/
static void AuxENSRamInit(void)
{
	(void)memset(&AuxENS, ZERO, sizeof(AUX_ENS_CTRL_T));
} /* End AuxENSProcess() */

/*****************************************************************************
*  AuxENSProcess:
*
*  PARAMETERS: None
*
*  DESCRIPTION: This function will monitor ENS severe timer.
*
*  RETURNS: New deployment happened or not
*
 ******************************************************************************/
static void AuxENSProcess(void)
{
	S16 vehicleY = ZERO;
	AUX_ENS_LEVELS_E level = ENS_LEVEL_INACTIVE;

	/* ENS Determination */
	if(TRUE == ENSCAL_ENS_REQUIRED)
	{
		vehicleY = CAW_GetVehicleYData() / ACU_LPF_DIVIDE;
		AuxENSLevelUpdate(vehicleY);
		if(TRUE == AuxENSMonitor())
		{
		 /*******************Add your code here********************************/
			ENS_Active();
			(void)memset(&AuxENS, ZERO, sizeof(AUX_ENS_CTRL_T));
		}
	}
} /* End AuxENSProcess() */

/*****************************************************************************
*  AuxENSMonitor:
*
*  PARAMETERS: None
*
*  DESCRIPTION: This function will monitor ENS severe timer.
*
*  RETURNS: New deployment happened or not
*
 ******************************************************************************/
static UNS8 AuxENSMonitor(void)
{
	UNS8 retval = FALSE;
	UNS8 dir = ENS_DIR_LEFT;

	for (dir = ENS_DIR_LEFT; dir < ENS_DIR_NUM; dir ++)
	{
		if (AuxENS.Level[dir] != ENS_LEVEL_INACTIVE)
		{
			retval = TRUE;
		}
	}

	return(retval);
} /* End AuxENSMonitor() */


/*****************************************************************************
*  AuxENSLevelUpdate:
*
*  PARAMETERS: None
*
*  DESCRIPTION: This function will get the side deployment level for ENS.
*
*  RETURNS: Deployment level
*
 ******************************************************************************/
static void AuxENSLevelUpdate(S16 inputData)
{
	/*Check whether the VelocityCalcFlag status has change.*/
	if (FALSE == AuxENS.VelocityCalcFlag)
	{
		/*Check whether input acc has reached the threshold.*/
		if (TRUE == IS_OUT_RANGE_BOUNDARY(inputData,-(S16)(ENSCAL_SIDE_VEL_START),ENSCAL_SIDE_VEL_START))
		{
			/*YES,Reached the threshold.*/
			AuxENS.VelocityCalcFlag = TRUE;
		}
	}
	else
	{
		if (TRUE == IS_IN_RANGE_NOBOUNDARY(inputData,-(S16)(ENSCAL_SIDE_VEL_START),ENSCAL_SIDE_VEL_START))
		{
			AuxENS.LowVelocityCnt++;
			if(AuxENS.LowVelocityCnt >= ENSCAL_SIDE_VEL_EXIT)
			{
				AuxENS.VelocityCalcFlag = FALSE;
				AuxENS.Velocity = ZERO;
				AuxENS.LowVelocityCnt = ZERO;
				memset(AuxENS.Level, ENS_LEVEL_INACTIVE, sizeof(AUX_ENS_LEVELS_E) * ENS_DIR_NUM);
			}
		}
		else
		{
			AuxENS.LowVelocityCnt = 0;
		}
	}

	/* Calculate Side AuxENS.Velocity */
	if (TRUE == AuxENS.VelocityCalcFlag)
	{
		AuxENS.LowVelocityCnt = ZERO;
		AuxENS.Velocity += inputData;

		/* update AuxENS.Velocity value*/
		if (AuxENS.Velocity > ENSCAL_SIDE_VELOCITY_FF)
		{
			AuxENS.Velocity -= (S16)ENSCAL_SIDE_VELOCITY_FF;
		}
		else if (AuxENS.Velocity < (-(S16)ENSCAL_SIDE_VELOCITY_FF))
		{
			AuxENS.Velocity += (S16)ENSCAL_SIDE_VELOCITY_FF;
		}
		else
		{
			AuxENS.Velocity = ZERO;
		}

		if (AuxENS.Velocity <= -((S16)ENSCAL_SIDE_SEVERE_TH))/*negative:driver side severe hit*/
		{
			AuxENS.Level[ENS_DIR_LEFT] = ENS_LEVEL_SEVERE;
		}
		else if (AuxENS.Velocity >= ENSCAL_SIDE_SEVERE_TH)/*positive:passenger side severe hit*/
		{
			AuxENS.Level[ENS_DIR_RIGHT] = ENS_LEVEL_SEVERE;
		}
		else if (AuxENS.Velocity <= -((S16)ENSCAL_SIDE_LIGHT_TH))/*negative:driver side light hit*/
		{
			AuxENS.Level[ENS_DIR_LEFT] = ENS_LEVEL_LIGHT;
		}
		else if (AuxENS.Velocity >= ENSCAL_SIDE_LIGHT_TH)/*positive:passenger side light hit*/
		{
			AuxENS.Level[ENS_DIR_RIGHT] = ENS_LEVEL_LIGHT;
		}
		else
		{
			/*Needn't update retEnsLevel value*/
		}
	}
}

#endif


/* End of file*/
