#ifndef __CAW_H__
#define __CAW_H__
/*****************************************************************************
 ********************code here*******************

 *****************************************************************************
 */
 /** INCLUDES **/
//#include "tpic71004_dtype.h"
#include "main.h"
/** MARCOS AND TYPEDEFs **/
/* Test_Trace:Test_ALGORITHM */
#define CAW_LEFT_SIDE_ALGORITHM 	(0U)
#define CAW_RIGHT_SIDE_ALGORITHM 	(1U)

	

typedef union
{
	struct
	{

#if (__JALG_ENABLE__ == 0)
		UNS16 Rear:1;
		UNS16 FuelCutOffReserved:1;
		UNS16 FuelCutOff:1;
		UNS16 RollReserved:1;
		UNS16 Roll:1;
		UNS16 RightReserved2:1;
		UNS16 RightReserved1:1;
		UNS16 Right:1;
		UNS16 LeftReserved2:1;
		UNS16 LeftReserved1:1;
		UNS16 Left:1;
		UNS16 Level_5:1;
		UNS16 Level_4:1;
#else
		UNS16 RearReserved2:1;
		UNS16 RearReserved1:1;
		UNS16 Rear:1;
		UNS16 FuelCutOffReserved:1;
		UNS16 FuelCutOff:1;
		UNS16 RollReserved:1;
		UNS16 Roll:1;
		UNS16 RightReserved2:1;
		UNS16 Right_1:1;
		UNS16 Right:1;
		UNS16 LeftReserved2:1;
		UNS16 Left_1:1;
		UNS16 Left:1;
#endif		
		UNS16 Level_3:1;
		UNS16 Level_2:1;
		UNS16 Level_1:1;
	} Bit;
	UNS16 Word;
} DECISIONLEVEL_U;

/* Test_Trace:Test_CAW_T */
typedef struct CAW_T
{
	UNS8	EnabledAlgorithm;
	union
	{
		struct
		{
			BIT_FIELD	IsCrashActive	:1;
			BIT_FIELD	IsLeftActive	:1;
			BIT_FIELD	IsRightActive	:1;
			BIT_FIELD	IsFrontActive	:1;
			BIT_FIELD	WasCrashActive	:1;
			BIT_FIELD	WasLeftActive	:1;
			BIT_FIELD	WasRightActive	:1;
			BIT_FIELD	WasFrontActive	:1;
		} Bit;
		UNS8	Part;
	} CrashAlgActive;

	union
	{
		struct
		{
			BIT_FIELD	IsFrontEnabled 	:1;
			BIT_FIELD	IsLeftEnabled 	:1;
			BIT_FIELD	IsRightEnabled 	:1;
			BIT_FIELD	Reserved 		:5;
		} Bit;
		UNS8	Part;
	} CrashAlgEnable;

	struct
	{
		S16	X;
		S16	Y;
		S16	Z;
	} AccData;

	struct
	{
/* WARNING: Keep "Stuffing" here to ensure TAF_Algo() and TAS_Algo() get RSU data */
		S16 Stuffing;
		/*S16 scsl;
		S16 scsr;*/
/* WARNING: The order from LFIS to RCSIS, can NOT be changed */
/* SAT_GetAccData() copy RSU data by the order */
		S16 LFIS;    	/* Left Front Impact Sensor */
        S16 RFIS;    	/* Right Front Impact Sensor */
        S16 LSIS;    	/* Left Side Impact Sensor */
	    S16 RSIS;    	/* Right Side Impact Sensor */
		S16 LCSIS;   	/* Left C-Pillar Side Impact Sensor */
		S16 RCSIS;   	/* Right C-Pillar Side Impact Sensor */
		S16 LRPS;		/* Left Remote Pressure Sensor */
		S16 RRPS;		/* Right Remote Pressure Sensor */
		S16 LPTS;		/* Left Pedestrian Tube Sensor */
		S16 RPTS;		/* Right Pedestrian Tube Sensor */
	} RSUData;

	UNS16 CrashAlgTimer; /* ca -- crash alogorithm */
	UNS16 BattLevelAlgEntry;
	UNS16 BattDisconnectTime;
	UNS16 VoltageEnergyReserve;
	UNS16 VoltageTopCap;
	UNS16 VehicleSpeed;
	UNS16 SafingSwitchClosureTime;

	union
	{
		struct
		{
			BIT_FIELD	Front 	:1;
			BIT_FIELD	Left 	:1;
			BIT_FIELD	Right 	:1;
			BIT_FIELD	Reserved :5;
		} Bit;
		UNS8	Part;
	} IsAlgoCalledYet;
	UNS8 Reserved[2];
	/*for Safing Acc*/

#if (__FUEL_CUTOFF__ == 1)
	union
	{
		struct
		{
			BIT_FIELD	IsAlgEnabled :1;
			BIT_FIELD	IsAlgActive :1;
			BIT_FIELD	Reserved :6;
		} Bit;
		UNS8	Part;
	} RollAlg;
#endif
	DECISIONLEVEL_U CacheAlgDecisionLevel;
} CAW_T;

/** PUBLIC DATA **/
extern CAW_T CAW;
//extern volatile uint32_t algorithmFireTime;
//extern volatile uint32_t algorithmStartTime;
//extern volatile uint32_t algorithmFireFlag;
/**	PUBLIC FUNCTION PROTOTYPES **/
extern void CAW_RamInit(void);
//extern BOOL CAW_ActiveAlgorithm(void);
#if (__FUEL_CUTOFF__ == 1)
extern BOOL CAW_FuelCutoffAlgoActive(void);
#endif
extern void CAW_frontal(void);
extern void CAW_sides(void);
extern void CAW_RunStop(void);
extern void CAW_SetEnableDisableState(void);
extern S16 CAW_GetVehicleYData(void);
extern void CAW_GetSatelliteData(void);
uint32_t S_GetAlgorithmFireTime(void);

#endif /* __CAW_H__ */


