/*
 * dpl.c
 *
 *  Created on: Jan 9, 2024
 *      Author: liuzhimin
 */


#include "main.h"
//#include "front.h"
typedef enum
{
	YES = 0x33,
	NO = 0xCC
} YES_NO_E;


#define FIRE_LOGI_BST_DW_ON() 			LL_GPIO_ResetOutputPin(GPIOA,LL_GPIO_PIN_10);/*CTL2*///BSP_GPIO_Write(GPIO_OUT_BST_CTL2,0);
#define FIRE_LOGI_BST_DW_OFF() 			LL_GPIO_SetOutputPin(GPIOA,LL_GPIO_PIN_10);/*CTL2*///BSP_GPIO_Write(GPIO_OUT_BST_CTL2,1);
#define FIRE_LOGI_BST_UP_ON()  			LL_GPIO_ResetOutputPin(GPIOA,LL_GPIO_PIN_8);/*CTL4*///BSP_GPIO_Write(GPIO_OUT_BST_CTL4,0);
#define FIRE_LOGI_BST_UP_OFF()  		LL_GPIO_SetOutputPin(GPIOA,LL_GPIO_PIN_8);/*CTL4*///BSP_GPIO_Write(GPIO_OUT_BST_CTL4,1);
//#define FIRE_LOGI_LOW_ON() 				LL_GPIO_SetOutputPin(GPIOA,LL_GPIO_PIN_11);/*CTL1*///BSP_GPIO_Write(GPIO_OUT_BST_CTL1,1);
//#define FIRE_LOGI_LOW_OFF() 			LL_GPIO_ResetOutputPin(GPIOA,LL_GPIO_PIN_11);/*CTL1*///BSP_GPIO_Write(GPIO_OUT_BST_CTL1,0);
#define FIRE_LOGI_HIGH_ON() 			LL_GPIO_ResetOutputPin(GPIOA,LL_GPIO_PIN_9);/*CT1*////BSP_GPIO_Write(GPIO_OUT_MCU_CT1,1);
#define FIRE_LOGI_HIGH_OFF() 			LL_GPIO_SetOutputPin(GPIOA,LL_GPIO_PIN_9);/*CT1*///BSP_GPIO_Write(GPIO_OUT_MCU_CT1,0);
#define ACC_INT_STATUS()				LL_GPIO_IsInputPinSet(GPIOB,LL_GPIO_PIN_9)


#define FIRE_LOGI_SAFETY_UNLOCK() 		LL_GPIO_ResetOutputPin(GPIOA,LL_GPIO_PIN_11);/*MCU_CT3*/
#define FIRE_LOGI_SAFETY_LOCK() 		LL_GPIO_SetOutputPin(GPIOA,LL_GPIO_PIN_11);/*MCU_CT3*/



#define BOOST_SWITCH_DELAY_TIME     (1)/*Capacitive boost MOS switching timing*/
#define CAP_TO_FIRE_DELAY_TIME      (1)/*Capacitor boost to ignition time*/
#define HOLD_FIRE_DELAY_TIME    	(8)/*Hold time after ignition*/



#define ON_BOOST_FIRST_STEP     (0)
#define ON_BOOST_DELAY_STEP     ((BOOST_SWITCH_DELAY_TIME*1))
#define ON_FIRE_DELAY_STEP      ((CAP_TO_FIRE_DELAY_TIME*1) + ON_BOOST_DELAY_STEP)
#define HOLD_FIRE_DELAY_STEP    ((HOLD_FIRE_DELAY_TIME*1) + ON_FIRE_DELAY_STEP)
#define HOLD_FIRE_DELAY_STEP_4MS    (9)


static UNS16 fireStep;

/** PRIVATE DATA **/
static UNS8 CrashFaultCalled;
static UNS8 RecordVoltageAfterSquibFire;
static UNS8 SquibFireFlag;
static UNS32 SquibDeployed;
static BOOL SquibInterLock;
UNS8 EDR_FireTimer = 0;
/** LOCAL FUNCTION PROTOTYPES **/
static void DeployLogic(void);

/*****************************************************************************
 *	DPL_GetSquibInterLockFlag:
 *
 *	PARAMETERS: void
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Get the current ignition status
 *
 *	RETURNS: BOOL
 *
 *****************************************************************************
 */
BOOL DPL_GetSquibInterLockFlag(void)
{
	return SquibInterLock;
}

/*****************************************************************************
 *	DPL_RamInit:
 *
 *	PARAMETERS: void
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Module memory initialization
 *
 *	RETURNS: void
 *
 *****************************************************************************
 */
void DPL_RamInit(void)
{
	//memset(&DPL_MASK[0], 0, sizeof(DPL_MASK));
//	DPL_DeployDelayDataLoad = FALSE;

//	FRONT_DECISION_LEVEL[TAF_LEVEL_0] = ZERO;
//	FRONT_DECISION_LEVEL[TAF_LEVEL_1] = ZERO;
//	FRONT_DECISION_LEVEL[TAF_LEVEL_2] = ZERO;
	SquibFireFlag = TRUE;
	SquibInterLock = FALSE;
	fireStep = 0;
} /* End DPL_RamInit */


/*****************************************************************************
 *	DPL_ACC_IntState:
 *
 *	PARAMETERS: void
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Obtain ignition status
 *
 *	RETURNS: UNS8
 *
 *****************************************************************************
 */

UNS8 DPL_AlgorithmState(void)
{
	return SquibFireFlag;
}




/*****************************************************************************
 *	DPL_ACC_IntState:
 *
 *	PARAMETERS: void
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Obtain sensor status
 *
 *	RETURNS: UNS8
 *
 *****************************************************************************
 */
UNS8 DPL_ACC_IntState(void)
{
	return ACC_INT_STATUS();
}


/* Test_Trace:Test_DPL_AlgorithmStartup */
void DPL_AlgorithmStartup(void)
{
//	UNS8 squib_number = ZERO;

	RecordVoltageAfterSquibFire = FALSE;

	/* clear squib deployed structure */
	SquibDeployed = ZERO;
	fireStep = 0;
	SquibFireFlag = TRUE;



	CrashFaultCalled = ZERO;
}  /*End DPL_AlgorithmStartup */



/*****************************************************************************
 *	DPL_Periodic:
 *
 *	PARAMETERS: void
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Ignition logic entrance
 *
 *	RETURNS: void
 *
 *****************************************************************************
 */
void DPL_Periodic(void)
{

	if((FRONT_DECISION_LEVEL[TAF_LEVEL_0] != 0)
		|| (FRONT_DECISION_LEVEL[TAF_LEVEL_1] != 0)
		|| (FRONT_DECISION_LEVEL[TAF_LEVEL_2] != 0)){
		if(ACC_INT_STATUS()){
			DeployLogic();
		}

	}
	PWR_HighPowerDelay();
}  /*End DPL_Periodic */


/*****************************************************************************
 *	driveMosDelay:
 *
 *	PARAMETERS: void
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: MOS switching hardware delay
 *
 *	RETURNS: void
 *
 *****************************************************************************
 */

void driveMosDelay(void)
{
	UNS32 us_delay = 1000;
	while(us_delay--){}
}

/*****************************************************************************
 *	DeployLogic:
 *
 *	PARAMETERS: void
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Ignition logic circuit detection and execution
 *
 *	RETURNS: void
 *
 *****************************************************************************
 */
static void DeployLogic(void)
{
	/*Ignition core logic*/
	/*All peripheral hardware switches*/
	if(ACC_INT_STATUS()){
		/*software switch*/
		if(SquibFireFlag == TRUE){
			if(fireStep == ON_BOOST_FIRST_STEP)
			{
				if(!AdKey_GetDeviceStatus()){
					SquibFireFlag = FALSE;
					FIRE_LOGI_SAFETY_LOCK();
					FIRE_LOGI_BST_UP_OFF();
					FIRE_LOGI_BST_DW_OFF();
					FIRE_LOGI_HIGH_OFF();
					/*FIRE_LOGI_LOW_OFF();*/
					fireStep = 0;
					return;
				}else{
					PWR_IntAllDisable();
					REC_SignalFireRecord();
					FIRE_LOGI_SAFETY_UNLOCK();
					FIRE_LOGI_BST_DW_ON();
					SquibInterLock = TRUE;
					EDR_FireTimer = EDR_AccDataInx;
					DEBUG_EDRfireFlag();
					driveMosDelay();
					FIRE_LOGI_BST_UP_ON();
					driveMosDelay();
					FIRE_LOGI_HIGH_ON();
				}
			}else if(fireStep == HOLD_FIRE_DELAY_STEP_4MS){


				/*step 4: Complete the ignition steps and return to the initial state*/
				FIRE_LOGI_BST_UP_OFF();
				FIRE_LOGI_BST_DW_OFF();
				FIRE_LOGI_HIGH_OFF();
				/*FIRE_LOGI_LOW_OFF();*/
				SquibFireFlag = FALSE;
				SquibInterLock = FALSE;
				Disp_UpdateData(TRIGGE_TYPE_KEY);

				DEBUG_EDRFireFlagLast();
				REC_SignalOffMosRecord();
				PWR_IntAllEnable();
				FIRE_LOGI_SAFETY_LOCK();
			}
			fireStep++;
		}
	}else{
		/*Ensure that the status is not ignited*/
		if(fireStep)
		{
			/*Zero state*/
			FIRE_LOGI_BST_UP_OFF();
			FIRE_LOGI_BST_DW_OFF();
			FIRE_LOGI_HIGH_OFF();
			/*FIRE_LOGI_LOW_OFF();*/
			fireStep = 0;
			DEBUG_EDRFireFlagLast();
			REC_SignalOffMosRecord();
			PWR_IntAllEnable();
			FIRE_LOGI_SAFETY_LOCK();
		}
	}

}  /* DeployLogic */











