/*
 * ecap.h
 *
 *  Created on: Jan 9, 2024
 *      Author: liuzhimin
 */

#ifndef DPL_ERCAP_H_
#define DPL_ERCAP_H_


typedef enum
{
	ERCAP_STEP_INIT = 0,				/* Initial step,BOOST_ENABLE */
	ERCAP_STEP_TEST_BOOST,              /* Check if the boost is complete */
	ERCAP_STEP_DIAG_CAP,                /*Diagnostic Capacitor*/
	ERCAP_STEP_NORMAL,					/* ER SWITCH step END */
	ERCAP_STEP_ERROR,					/* ER SWITCH step END */
	ERCAP_STEP_MAX
} ERCAP_STEP_E;


typedef enum
{
	ERCAP_DIAG_NOT_COMPLETE = 0,		/* ERCAP diagnostic is not complete */
	ERCAP_DIAG_CAN_NOT_TEST,			/* ERCAP diagnostic can not be test */
	ERCAP_DIAG_ERC_MISS,				/* ERC missing */
	ERCAP_DIAG_ERC_SHORT,				/* ERC short */
	ERCAP_DIAG_ERC_INVALID,				/* ERC is out of the range */
	ERCAP_DIAG_CHARGE_FAULT,			/* The charge current source fault  */
	ERCAP_DIAG_ESR_INVALID,				/* ESR is out of the range */
	ERCAP_DIAG_OK,						/* ERC and ESR are in the range */
	ERCAP_DIAG_MAX						/* ERC and ESR are in the range */
} ERCAP_DIAG_STATUS_E;






void BoostON(void);
void BoostOFF(void);

ERCAP_STEP_E ERCAP_GetErcapState(void);
void ERCAP_RamInit(void);
void ERCAP_ExecRoutine(void);
UNS8 ERCAP_GetVerVlot(void);




#endif /* DPL_ERCAP_H_ */
