
#include "cTask.h"
#include "cTaskApp.h"
#include "main.h"

void PWR_UpdateHighPower(void);


/*****************************************************************************
 *	COMMON_2MSTask:
 *
 *	PARAMETERS: VOID
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Task 2ms call
 *
 *	RETURNS: VOID
 *
 *****************************************************************************
 */
void COMMON_2MSTask(void)/* 2ms */
{
	BSP_FeedWWDG();

//***********2ms*********/

	ADC_Test();
	IOKey_Routine();
	AdKey_Routine();
	Disp_Routine();
	LV595_Routine();
	AL_Routine();
	DIAG_Routine();
	ACC_Routine();
	ProcessBleConnDisconn();
	PWR_Manage();

}

/*****************************************************************************
 *	COMMON_5MSTask:
 *
 *	PARAMETERS: VOID
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Task 5ms call
 *
 *	RETURNS: VOID
 *
 *****************************************************************************
 */
void COMMON_5MSTask(void)
{
	DEBUG_Routine();
}

/*****************************************************************************
 *	FAN_20MSTask:
 *
 *	PARAMETERS: VOID
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Task 20ms call
 *
 *	RETURNS: VOID
 *
 *****************************************************************************
 */
void FAN_20MSTask(void)
{
	Fan_Routine();
    TEMP_Routine();
	if(POWER_LOOP_MODE_HIGH == PWR_GetLoopMode())/*power_mode*/
	{
	    CAW_SetEnableDisableState();
	}

}


/*****************************************************************************
 *	ISR_05MSTask:
 *
 *	PARAMETERS: VOID
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Int Task 0.5ms
 *
 *	RETURNS: VOID
 *
 *****************************************************************************
 */
void ISR_05MSTask(void)/* isr*/
{

	PWR_UpdateHighPower();
	/*sensor*/
	ACC_DataRoutine();
	/*The following only runs in 80M mode, do not run in 4M mode*/
	//***********0.5ms*********/
	if(POWER_LOOP_MODE_HIGH == PWR_GetLoopMode())/*power_mode*/
	{

		CAW_frontal();
/*EdrDataGetFromAlgo();*/
#ifndef REC_TO_FLASH_TEST_ENABLE
		REC_Routine();
#endif
		DEBUG_EDRAccDataSave();
		CAW_RunStop();

		/*Retrieve ACC data and call this interface*/
		/*BOOL ACCEL_GetAccelData(S16_PTR const data_x, S16_PTR const data_y);*/

		/*Determine if ACC calls this interface abnormally*/
		/*BOOL ACC_IsStatusGood(void);*/

		/*Exit power mode to sleep interface*/
		/*void PWR_ExitHighPower(void);*/
		/*Get system time interface*/
		/*uint32_t cTASK_GetSysTimer(void)*/


		/*algo*/
		/*fire*/
		PWR_OffHighPower();
	}
}



/*****************************************************************************
 *	APP_TASK_Init:
 *
 *	PARAMETERS: VOID
 *
 *	CONSTRAINTS: None
 *
 *	DESCRIPTION: Task initialization
 *
 *	RETURNS: VOID
 *
 *****************************************************************************
 */
void APP_TASK_Init(void)
{
	cTASK_Init();
	if(VER_CONFG()){
		cTASK_IsrCreat(ISR_05MSTask, 1);/* 0.5ms*/
		cTASK_Creat(COMMON_2MSTask, 4, 2);/* 2ms*/
		cTASK_Creat(COMMON_5MSTask, 10, 3);/* 5ms*/
		cTASK_Creat(FAN_20MSTask, 40, 4);/* 20ms*/

		cTASK_Creat(BleCmdProcess, 100, 7);
		cTASK_Creat(BleReportDeviceSts, 100, 8); //50ms
	}
}




