/*
 * Display.h
 *
 *  Created on: Dec 1, 2023
 *      Author: liuzhimin
 */

#ifndef RTE_74LV595_H_
#define RTE_74LV595_H_


typedef enum
{
//	LV595_STATUS_NRST = 0,			/*Initialization status */
	LV595_STATUS_INIT = 0,
	LV595_STATUS_REFRESH,			/*Update serial data to display*/
	LV595_STATUS_WAIT,				/*Waiting for ADC data to come over*/
	LV595_STATUS_FAILURE,			/*Led SPI error status */
	LV595_STATUS_OFF,				/*OFF led */
} LV595_STATUS_E;


typedef	union
{
	struct
	{
		UNS32 led_D11:1;/*SOS*/
		UNS32 led_D12:1;/*Power green light*/
		UNS32 led_D13:1; /*Power red light*/
		UNS32 led_D14:1;/*reverse red light*/
		UNS32 led_D15:1;/*reverse green light*/
		UNS32 led_D16:1;/*ISOFIX  red light*/
		UNS32 led_D17:1;/*ISOFIX  green light*/
		UNS32 led_D18:1;/*buckle  red light*/
		UNS32 led_D19:1;/*buckle  green light*/
		UNS32 led_D20:1;/*leg green light*/
		UNS32 led_D21:1;/*leg red light*/
		UNS32 led_D22:1;/*forward  red light*/
		UNS32 led_D23:1;/*forward  green light*/
		UNS32 led_D24:1;/*ISOFIX  green light*/
		UNS32 led_D25:1;/*ISOFIX  red light*/
		UNS32 led_D26:1;/*5VIN  white light*/
		UNS32 Reserved_21:1;/**/
		UNS32 led_D27:1;/*fan_1*/
		UNS32 led_D28:1;/*fan_2*/
		UNS32 led_D29:1;/*fan_3*/
		UNS32 led_D37:1;/*air_bag**/
		UNS32 led_D47:1;/*head_1*/
		UNS32 led_D46:1;/*head_2*/
		UNS32 Reserved_24:1;/**/
		UNS32 Reserved_25:1;/**/
		UNS32 Reserved_26:1;/**/
		UNS32 Reserved_27:1;/**/
		UNS32 Reserved_28:1;/**/
		UNS32 Reserved_29:1;/**/
		UNS32 Reserved_30:1;/**/
		UNS32 Reserved_31:1;/**/
		UNS32 Reserved_32:1;/**/
	} Bit;
	UNS32 Dword;

} LV595_DATA32_U;



extern void LV595_Enable(void);
extern LV595_STATUS_E LV595_GetStatus(void);
extern void LV595_Disable(void);
extern void LV595_UpdateData(UNS32 data);

extern void LV595_RamInit(void);
extern void LV595_Routine(void);



#endif /* RTE_74LV595_H_ */
