/*
 * adckey.h
 *
 *  Created on: Dec 14, 2023
 *      Author: liuzhimin
 */

#ifndef RTE_ADCKEY_H_
#define RTE_ADCKEY_H_



typedef enum {
	ADK_STATUS_INACTIVE = 0,
	ADK_STATUS_ACTIVE,
} ADK_ACTIVE_E;

typedef enum {
	SWITCH_STATUS_NO_INSEST = 0,
	SWITCH_STATUS_OFF,
	SWITCH_STATUS_ON,
} SWITCH_STATUS_E;

typedef enum {
	SWITCH_STATUS2_ON = 0,
	SWITCH_STATUS2_OFF,
} SWITCH_STATUS2_E;


typedef enum {
	ADK_VALUE_MODE_OFF = 0,
	ADK_VALUE_MODE_1,
	ADK_VALUE_MODE_2,
	ADK_VALUE_MODE_3,
} ADK_KEY_E;

typedef enum {
	ADK2_VALUE_MODE_OFF = 0,
	ADK2_VALUE_MODE_ON,
	ADK2_VALUE_MODE_1,
} ADK2_KEY_E;



typedef enum
{
	ADKEY_DIR_ERROR_NO = 0,
	ADKEY_DIR_ERROR_ALL,
	ADKEY_DIR_FRONT,
	ADKEY_DIR_BACK,
} ADKEY_DIR_E;

typedef enum
{
	ADKEY_SOS_OFF = 0,
	ADKEY_SOS_ON =!ADKEY_SOS_OFF,

} ADKEY_SOS_E;


typedef enum {

	ADKEY_SW3_ISOFIX0 = 0,/*ISOFIX 2*/
	ADKEY_SW3_ISOFIX1,/*ISOFIX 2*/
	ADKEY_SW3_DIR0,/*Direction 2*/
	ADKEY_SW3_DIR1,/*Direction 2*/
	ADKEY_SW3_LEG, /*Supporting leg 2*/
	ADKEY_SW3_PILLOW, /*pillow head 2*/
	ADKEY_SW2_BUCKLE,/*buckle */
	ADKEY_SW2_SOS,/*SOS*/
	ADKEY_SW2_5V,/* 5v In*/
//	ADKEY_SW2_PWR,/*Low Power*/
	ADKEY_SW_MAX,
} ADKEY_SW_CH_E;



typedef	union
{
	struct
	{
		UNS32 SW_ISOFIXR:2;
		UNS32 SW_ISOFIXL:2;
		UNS32 SW_DIRF:2;
		UNS32 SW_DIRB:2;
		UNS32 SW_LEG:2;
		UNS32 SW_PILLOW:2;
		UNS32 SW_BUCKLE:2;
		UNS32 SW_SOS:2;
		UNS32 SW_5V:2;
		UNS32 Reserved:14;
	} Bit;
	UNS32 Dword;

} ADK_SWITCH_U;



BOOL AdKey_GetDeviceStatus(void);
BOOL AdKey_GetAccIntStatus(void);
BOOL AdKey_IsLeftAndRightGateStaus(void);
BOOL AdKey_DeviceStatusSwitchLogic(BOOL sos);
ADKEY_DIR_E AdKey_IsFrontORBackGate(UNS16 SwValF,UNS16 SwValB);
SWITCH_STATUS_E AdKey_IsLeftAndRightGate(UNS16 SwValL,UNS16 SwValR);
ADK_ACTIVE_E ADKey_GetModuleStatus(void);
ADK_SWITCH_U AdKey_GetSwitchAll(void);
UNS8 AdKey_GetSwitchVal(ADKEY_SW_CH_E ch);
void AdKey_RamInit(void);
void AdKey_Routine(void);



#endif /* RTE_ADCKEY_H_ */
