/*
 * power.h
 *
 *  Created on: Dec 1, 2023
 *      Author: liuzhimin
 */

#ifndef RTE_PWR_H_
#define RTE_PWR_H_





/* Mode index */
typedef enum
{
	BAT_STATUS_UNREAD= 0,
	BAT_STATUS_FULL,
	BAT_STATUS_LOW,
	BAT_STATUS_EMPTY,
	BAT_STATUS_ERROR,
	//BAT_STATUS_SUPERCAP,
	BAT_STATUS_MAX,
} BAT_STATUS_E;



typedef enum
{
	MODULE_STATUS_INACTIVE= 0,
	MODULE_STATUS_ACTIVE =!MODULE_STATUS_INACTIVE,
} MODULE_STATUS_E;


/* Mode index */
typedef enum
{
	POWER_LOOP_MODE_HIGH = 0,
	POWER_LOOP_MODE_NORMAL,
	POWER_LOOP_MODE_SLEEP,
	POWER_LOOP_MODE_MAX,
} POWER_MODE_E;

typedef enum
{
	WAKE_SWITCH = 0,
	WAKE_KEY,
	WAKE_SENSOR,
	WAKE_MAX,
} WAKE_EVENT_E;

//__STATIC_INLINE void NVIC_SystemReset(void)
//{
// __DSB();                                                          /* Ensure all outstanding memory accesses included
//																	   buffered write are completed before reset */
//  SCB->AIRCR  = (uint32_t)((0x5FAUL << SCB_AIRCR_VECTKEY_Pos)    |
//						   (SCB->AIRCR & SCB_AIRCR_PRIGROUP_Msk) |
//							SCB_AIRCR_SYSRESETREQ_Msk    );         /* Keep priority group unchanged */
//  __DSB();                                                          /* Ensure completion of memory access */
//
//  for(;;)                                                           /* wait until reset */
//  {
//	__NOP();
//  }
//}

void PWR_IntAllEnable(void);
void PWR_IntAllDisable(void);

UNS8 PWR_GetElecLevel(void);
BOOL PWR_GetUartInitDelayState(void);
void PWR_OffUartInitDelay(void);
void PWR_AccCurrentManagement(void);
void PWR_OffHighPower(void);
void PWR_HighPowerDelay(void);
void PWR_ExitHighPower(void);
void PWR_UpdateHighState(void);
BAT_STATUS_E PWR_GetLowBat(void);
void PWR_SetKeyWakeEvent(void);
void PWR_SetSensorWakeEvent(void);
void PWR_SetLoopMode(POWER_MODE_E mode);
extern void PWR_RamInit(void);
extern void PWR_Manage(void);
extern POWER_MODE_E PWR_GetLoopMode(void);
void PWR_UpdateBleState(void);
BAT_STATUS_E PWR_GetElecPtc(UNS8* pct);
UNS32 PWR_GetPowerSupplyOnfreq(void);
void PWR_ResetSleepTime(void);

void PWR_AccTestDelayCall(void);
BOOL PWR_getBatEmptyStats(void);
#endif /* RTE_PWR_H_ */
