/*
 * ver.h
 *
 *  Created on: Mar 5, 2024
 *      Author: liuzhimin
 */

#ifndef RTE_VER_H_
#define RTE_VER_H_


/****************硬件版本**********************/
#define HARDWARE_NAME           CS1000-E-001
#define HARDWARE_VER       		V03


/****************软件版本**********************/
#define ID              		GB
#define PROJECT_NAME            YXCS7100D
#define MAIN_VERSION    		1
#define SUB_VERSION				1
#define REVISED_VERSION			1
#define BUILD_NUMBER			V09071017.2

#define P(a) 			#a
#define MASK_P(a) 		P(a)


#define VER_FIXED_ENABLE




#ifdef  VER_FIXED_ENABLE

#define YEAR 		2024
#define MONTH 		12
#define DAY 		26

#else
#define YEAR 		(((	(__DATE__ [7 ] - '0') * 10  \
					  + (__DATE__ [8 ] - '0')) * 10 \
					  + (__DATE__ [9 ] - '0')) * 10 \
					  + (__DATE__ [10] - '0'))



#define MONTH 		( __DATE__ [2] == 'n' ? (__DATE__ [1] == 'a' ? 1 : 6) \
					: __DATE__ [2] == 'b' ? 2 \
					: __DATE__ [2] == 'r' ? (__DATE__ [0] == 'M' ? 3 : 4) \
					: __DATE__ [2] == 'y' ? 5	\
					: __DATE__ [2] == 'n' ? 6	\
					: __DATE__ [2] == 'l' ? 7	\
					: __DATE__ [2] == 'g' ? 8	\
					: __DATE__ [2] == 'p' ? 9	\
					: __DATE__ [2] == 't' ? 10	\
					: __DATE__ [2] == 'v' ? 11 : 12)

#define DAY 		( (__DATE__ [4] == ' ' ? 0 : __DATE__ [4] - '0') * 10 \
					+ (__DATE__ [5] - '0'))


#endif


#define HARDVERSION		\
		MASK_P(MAIN_VERSION)"-"\
		MASK_P(HARDWARE_NAME)"-"\
		MASK_P(HARDWARE_VER)\

#define VERSION		\
		MASK_P(ID)"-"\
		MASK_P(PROJECT_NAME)"-"\
		MASK_P(MAIN_VERSION)"."\
		MASK_P(SUB_VERSION)"."\
		MASK_P(REVISED_VERSION)"."\

#define BUILD__\
		MASK_P(BUILD_NUMBER)

#define VERSION_1 DAY

uint32_t VER_CRC32(uint32_t crc_in, uint8_t byte);
uint32_t VER_GetDate(void);
uint8_t VER_CONFG(void);
void VER_GetChipId(uint32_t *uid);

#endif /* RTE_VER_H_ */
